.ig
Copyright (C) 1989-2000, 2001, 2002, 2003, 2005 Free Software Foundation, Inc.

Permission is granted to make and distribute verbatim copies of
this manual provided the copyright notice and this permission notice
are preserved on all copies.

Permission is granted to copy and distribute modified versions of this
manual under the conditions for verbatim copying, provided that the
entire resulting derived work is distributed under the terms of a
permission notice identical to this one.

Permission is granted to copy and distribute translations of this
manual into another language, under the above conditions for modified
versions, except that this permission notice may be included in
translations approved by the Free Software Foundation instead of in
the original English.
..
.
.
.\" Like TP, but if specified indent is more than half
.\" the current line-length - indent, use the default indent.
.de Tp
.  ie \\n(.$=0:((0\\$1)*2u>(\\n(.lu-\\n(.iu)) .TP
.  el .TP "\\$1"
..
.
.de OP
.  ie \\n(.$-1 .RI "[\ \fB\\$1\fP\ " "\\$2" "\ ]"
.  el .RB "[\ " "\\$1" "\ ]"
..
.
.
.TH AFMTODIT @MAN1EXT@ "@MDATE@" "Groff Version @VERSION@"
.
.
.SH NAME
afmtodit \- create font files for use with groff \-Tps
.
.
.SH SYNOPSIS
.nr a \n(.j
.ad l
.nr i \n(.i
.in +\w'\fBafmtodit 'u
.ti \niu
.B afmtodit
.OP \-mnsvx
.OP \-a n
.OP \-d desc_file
.OP \-e enc_file
.OP \-i n
.I afm_file
.I map_file
.I font
.br
.ad \na
.
.LP
The whitespace between an command line option and its argument is optional.
.
.SH DESCRIPTION
.B afmtodit
creates a font file for use with groff and
.BR grops .
.
.B afmtodit
is written in perl;
you must have perl version 5.004 or newer installed in order to run
.BR afmtodit .
.
.LP
.I afm_file
is the AFM (Adobe Font Metric) file for the font.
.
.LP
.I map_file
is a file that says which groff character names map onto
each PostScript character name;
this file should contain a sequence of lines of the form
.IP
.I
ps_char groff_char
.LP
where
.I ps_char
is the PostScript name of the character
and
.I groff_char
is the groff name of the character (as used in the groff font file).
.
The same
.I ps_char
can occur multiple times in the file;
each
.I groff_char
must occur at most once.
.
Lines starting with
.B #
and blank lines are ignored.
.
If the file isn't found in the current directory, it is searched in
the `devps/generate' subdirectory of the default font directory.
.
.LP
If a PostScript character is not named as
.BI uni XXXX
.RI ( XXXX
are four uppercase hexadecimal digits), and is not mentioned in
.IR map_file ,
and a generic groff glyph name can't be deduced using the
Adobe Glyph List (AGL, built into
.BR  afmtodit ),
then
.B afmtodit
puts the PostScript character into the groff font file as an unnamed
character which can only be accessed by the
.B \eN
escape sequence in
.BR troff .
.
If option
.B \-e
is not specified, the encoding defined in the AFM file (i.e., entries
with non-negative character codes) is used.
.
Please refer to section `Using Symbols' in the groff info file which
describes how groff glyph names are constructed.
.
.LP
Characters not encoded in the AFM file (i.e., entries which have \-1 as
the character code) are still available in groff; they get glyph index
values greater than 255 (or greater than the biggest character code used
in the AFM file in the unlikely case that it is greater than 255) in the
groff font file.
.
Glyph indices of unencoded characters don't have a specific order; it
is best to access them with glyph names only.
.
.LP
The groff font file will be output to a file called
.IR font .
.
.LP
If there is a downloadable font file for the font, it may be listed in
the file
.BR @FONTDIR@/devps/download ;
see
.BR grops (@MAN1EXT@).
.
.LP
If the
.B \-i
option is used,
.B afmtodit
will automatically generate an italic correction,
a left italic correction and a subscript correction
for each character
(the significance of these parameters is explained in
.BR groff_font (@MAN5EXT@));
these parameters may be specified for individual characters by
adding to the
.I afm_file
lines of the form:
.IP
.BI italicCorrection\  ps_char\ n
.br
.BI leftItalicCorrection\  ps_char\ n
.br
.BI subscriptCorrection\  ps_char\ n
.LP
where
.I ps_char
is the PostScript name of the character,
and
.I n
is the desired value of the corresponding parameter in thousandths of an em.
.
These parameters are normally needed only for italic (or oblique) fonts.
.
.
.SH OPTIONS
.TP
.BI \-a n
Use
.I n
as the slant parameter in the font file;
this is used by groff in the positioning of accents.
.
By default
.B afmtodit
uses the negative of the ItalicAngle specified in the afm file;
with true italic fonts it is sometimes desirable to use
a slant that is less than this.
.
If you find that characters from an italic font have accents
placed too far to the right over them,
then use the
.B \-a
option to give the font a smaller slant.
.
.TP
.BI \-d desc_file
The device description file is
.I desc_file
rather than the default
.BR DESC .
.
If not found in the current directory, the `devps' subdirectory of the
default font directory is searched (this is true for both the default
device description file and a file given with option
.BR \-d ).
.
.TP
.BI \-e enc_file
The PostScript font should be reencoded to use the encoding described
in enc_file.
.
The format of
.I enc_file
is described in
.BR grops (@MAN1EXT@).
.
If not found in the current directory, the `devps' subdirectory of the
default font directory is searched.
.
.TP
.BI \-i n
Generate an italic correction for each character so that 
the character's width plus the character's italic correction
is equal to
.I n
thousandths of an em
plus the amount by which the right edge of the character's bounding box
is to the right of the character's origin.
.
If this would result in a negative italic correction, use a zero
italic correction instead.
.
.IP
Also generate a subscript correction equal to the 
product of the tangent of the slant of the font and
four fifths of the x-height of the font.
.
If this would result in a subscript correction greater than the italic
correction, use a subscript correction equal to the italic correction
instead.
.
.IP
Also generate a left italic correction for each character
equal to
.I n
thousandths of an em
plus the amount by which the left edge of the character's bounding box
is to the left of the character's origin.
.
The left italic correction may be negative unless option
.B \-m
is given.
.
.IP
This option is normally needed only with italic (or oblique) fonts.
.
The font files distributed with groff were created using an option of
.B \-i50
for italic fonts.
.
.TP
.B \-m
Prevent negative left italic correction values.
.
Roman font files distributed with groff were created with
.B \-i0\ \-m
to improve spacing with
.BR @g@eqn (@MAN1EXT@).
.
.TP
.B \-n
Don't output a
.B ligatures
command for this font.
.
Use this with constant-width fonts.
.
.TP
.B \-s
The font is special.
.
The effect of this option is to add the
.B special
command to the font file.
.
.TP
.B \-v
Print version.
.
.TP
.B \-x
Don't use the built-in Adobe Glyph List.
.
.
.SH FILES
.Tp \w'\fB@FONTDIR@/devps/download'u+2n
.B @FONTDIR@/devps/DESC
Device description file.
.
.TP
.BI @FONTDIR@/devps/ F
Font description file for font
.IR F .
.
.TP
.B @FONTDIR@/devps/download
List of downloadable fonts.
.
.TP
.B @FONTDIR@/devps/text.enc
Encoding used for text fonts.
.
.TP
.B @FONTDIR@/devps/generate/textmap
Standard mapping.
.
.
.SH "SEE ALSO"
.BR groff (@MAN1EXT@),
.BR grops (@MAN1EXT@),
.BR groff_font (@MAN5EXT@),
.BR perl (1)
.
.LP
The groff info file, section `Using Symbols'.
.
.\" Local Variables:
.\" mode: nroff
.\" End:
