/*	$OpenBSD: gallant12x22.h,v 1.2 2002/05/09 08:59:03 maja Exp $ */
/* 	$NetBSD: gallant12x22.h,v 1.2 1999/05/18 21:51:58 ad Exp $ */

/*-
 * Copyright (c) 1992, 1993
 *	The Regents of the University of California.  All rights reserved.
 *
 * This code is derived from software contributed to the Computer Systems
 * Engineering Group at Lawrence Berkeley Laboratory and to the University
 * of California at Berkeley by Jef Poskanzer.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 * 4. Neither the name of the University nor the names of its contributors
 *    may be used to endorse or promote products derived from this software
 *    without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE REGENTS AND CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE REGENTS OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 *
 * Derived from: @(#)gallant19.h	8.1 (Berkeley) 6/11/93
 */

#include <sys/cdefs.h>
__FBSDID("$FreeBSD: release/9.0.0/sys/dev/fb/gallant12x22.c 170840 2007-06-16 21:48:50Z marius $");

#include <sys/param.h>

#include <dev/fb/gfb.h>

const struct gfb_font gallant12x22 = {
	12,
	22,
	{
	/* 0 0x00 '^@' */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */

	/* 1 0x01 '^A' */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x3f, 0xc0,	/* ..********.. */
	0x3f, 0xc0,	/* ..********.. */
	0x3f, 0xc0,	/* ..********.. */
	0x3f, 0xc0,	/* ..********.. */
	0x3f, 0xc0,	/* ..********.. */
	0x3f, 0xc0,	/* ..********.. */
	0x3f, 0xc0,	/* ..********.. */
	0x3f, 0xc0,	/* ..********.. */
	0x3f, 0xc0,	/* ..********.. */
	0x3f, 0xc0,	/* ..********.. */
	0x3f, 0xc0,	/* ..********.. */
	0x3f, 0xc0,	/* ..********.. */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */

	/* 2 0x02 '^B' */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x3f, 0xc0,	/* ..********.. */
	0x3f, 0xc0,	/* ..********.. */
	0x3f, 0xc0,	/* ..********.. */
	0x3f, 0xc0,	/* ..********.. */
	0x3f, 0xc0,	/* ..********.. */
	0x3f, 0xc0,	/* ..********.. */
	0x3f, 0xc0,	/* ..********.. */
	0x3f, 0xc0,	/* ..********.. */
	0x3f, 0xc0,	/* ..********.. */
	0x3f, 0xc0,	/* ..********.. */
	0x3f, 0xc0,	/* ..********.. */
	0x3f, 0xc0,	/* ..********.. */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */

	/* 3 0x03 '^C' */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x3f, 0xc0,	/* ..********.. */
	0x3f, 0xc0,	/* ..********.. */
	0x3f, 0xc0,	/* ..********.. */
	0x3f, 0xc0,	/* ..********.. */
	0x3f, 0xc0,	/* ..********.. */
	0x3f, 0xc0,	/* ..********.. */
	0x3f, 0xc0,	/* ..********.. */
	0x3f, 0xc0,	/* ..********.. */
	0x3f, 0xc0,	/* ..********.. */
	0x3f, 0xc0,	/* ..********.. */
	0x3f, 0xc0,	/* ..********.. */
	0x3f, 0xc0,	/* ..********.. */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */

	/* 4 0x04 '^D' */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x3f, 0xc0,	/* ..********.. */
	0x3f, 0xc0,	/* ..********.. */
	0x3f, 0xc0,	/* ..********.. */
	0x3f, 0xc0,	/* ..********.. */
	0x3f, 0xc0,	/* ..********.. */
	0x3f, 0xc0,	/* ..********.. */
	0x3f, 0xc0,	/* ..********.. */
	0x3f, 0xc0,	/* ..********.. */
	0x3f, 0xc0,	/* ..********.. */
	0x3f, 0xc0,	/* ..********.. */
	0x3f, 0xc0,	/* ..********.. */
	0x3f, 0xc0,	/* ..********.. */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */

	/* 5 0x05 '^E' */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x3f, 0xc0,	/* ..********.. */
	0x3f, 0xc0,	/* ..********.. */
	0x3f, 0xc0,	/* ..********.. */
	0x3f, 0xc0,	/* ..********.. */
	0x3f, 0xc0,	/* ..********.. */
	0x3f, 0xc0,	/* ..********.. */
	0x3f, 0xc0,	/* ..********.. */
	0x3f, 0xc0,	/* ..********.. */
	0x3f, 0xc0,	/* ..********.. */
	0x3f, 0xc0,	/* ..********.. */
	0x3f, 0xc0,	/* ..********.. */
	0x3f, 0xc0,	/* ..********.. */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */

	/* 6 0x06 '^F' */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x3f, 0xc0,	/* ..********.. */
	0x3f, 0xc0,	/* ..********.. */
	0x3f, 0xc0,	/* ..********.. */
	0x3f, 0xc0,	/* ..********.. */
	0x3f, 0xc0,	/* ..********.. */
	0x3f, 0xc0,	/* ..********.. */
	0x3f, 0xc0,	/* ..********.. */
	0x3f, 0xc0,	/* ..********.. */
	0x3f, 0xc0,	/* ..********.. */
	0x3f, 0xc0,	/* ..********.. */
	0x3f, 0xc0,	/* ..********.. */
	0x3f, 0xc0,	/* ..********.. */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */

	/* 7 0x07 '^G' */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x3f, 0xc0,	/* ..********.. */
	0x3f, 0xc0,	/* ..********.. */
	0x3f, 0xc0,	/* ..********.. */
	0x3f, 0xc0,	/* ..********.. */
	0x3f, 0xc0,	/* ..********.. */
	0x3f, 0xc0,	/* ..********.. */
	0x3f, 0xc0,	/* ..********.. */
	0x3f, 0xc0,	/* ..********.. */
	0x3f, 0xc0,	/* ..********.. */
	0x3f, 0xc0,	/* ..********.. */
	0x3f, 0xc0,	/* ..********.. */
	0x3f, 0xc0,	/* ..********.. */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */

	/* 8 0x08 '^H' */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x3f, 0xc0,	/* ..********.. */
	0x3f, 0xc0,	/* ..********.. */
	0x3f, 0xc0,	/* ..********.. */
	0x3f, 0xc0,	/* ..********.. */
	0x3f, 0xc0,	/* ..********.. */
	0x3f, 0xc0,	/* ..********.. */
	0x3f, 0xc0,	/* ..********.. */
	0x3f, 0xc0,	/* ..********.. */
	0x3f, 0xc0,	/* ..********.. */
	0x3f, 0xc0,	/* ..********.. */
	0x3f, 0xc0,	/* ..********.. */
	0x3f, 0xc0,	/* ..********.. */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */

	/* 9 0x09 '^I' */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x3f, 0xc0,	/* ..********.. */
	0x3f, 0xc0,	/* ..********.. */
	0x3f, 0xc0,	/* ..********.. */
	0x3f, 0xc0,	/* ..********.. */
	0x3f, 0xc0,	/* ..********.. */
	0x3f, 0xc0,	/* ..********.. */
	0x3f, 0xc0,	/* ..********.. */
	0x3f, 0xc0,	/* ..********.. */
	0x3f, 0xc0,	/* ..********.. */
	0x3f, 0xc0,	/* ..********.. */
	0x3f, 0xc0,	/* ..********.. */
	0x3f, 0xc0,	/* ..********.. */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */

	/* 10 0x0a '^J' */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x3f, 0xc0,	/* ..********.. */
	0x3f, 0xc0,	/* ..********.. */
	0x3f, 0xc0,	/* ..********.. */
	0x3f, 0xc0,	/* ..********.. */
	0x3f, 0xc0,	/* ..********.. */
	0x3f, 0xc0,	/* ..********.. */
	0x3f, 0xc0,	/* ..********.. */
	0x3f, 0xc0,	/* ..********.. */
	0x3f, 0xc0,	/* ..********.. */
	0x3f, 0xc0,	/* ..********.. */
	0x3f, 0xc0,	/* ..********.. */
	0x3f, 0xc0,	/* ..********.. */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */

	/* 11 0x0b '^K' */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x3f, 0xc0,	/* ..********.. */
	0x3f, 0xc0,	/* ..********.. */
	0x3f, 0xc0,	/* ..********.. */
	0x3f, 0xc0,	/* ..********.. */
	0x3f, 0xc0,	/* ..********.. */
	0x3f, 0xc0,	/* ..********.. */
	0x3f, 0xc0,	/* ..********.. */
	0x3f, 0xc0,	/* ..********.. */
	0x3f, 0xc0,	/* ..********.. */
	0x3f, 0xc0,	/* ..********.. */
	0x3f, 0xc0,	/* ..********.. */
	0x3f, 0xc0,	/* ..********.. */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */

	/* 12 0x0c '^L' */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x3f, 0xc0,	/* ..********.. */
	0x3f, 0xc0,	/* ..********.. */
	0x3f, 0xc0,	/* ..********.. */
	0x3f, 0xc0,	/* ..********.. */
	0x3f, 0xc0,	/* ..********.. */
	0x3f, 0xc0,	/* ..********.. */
	0x3f, 0xc0,	/* ..********.. */
	0x3f, 0xc0,	/* ..********.. */
	0x3f, 0xc0,	/* ..********.. */
	0x3f, 0xc0,	/* ..********.. */
	0x3f, 0xc0,	/* ..********.. */
	0x3f, 0xc0,	/* ..********.. */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */

	/* 13 0x0d '^M' */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x3f, 0xc0,	/* ..********.. */
	0x3f, 0xc0,	/* ..********.. */
	0x3f, 0xc0,	/* ..********.. */
	0x3f, 0xc0,	/* ..********.. */
	0x3f, 0xc0,	/* ..********.. */
	0x3f, 0xc0,	/* ..********.. */
	0x3f, 0xc0,	/* ..********.. */
	0x3f, 0xc0,	/* ..********.. */
	0x3f, 0xc0,	/* ..********.. */
	0x3f, 0xc0,	/* ..********.. */
	0x3f, 0xc0,	/* ..********.. */
	0x3f, 0xc0,	/* ..********.. */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */

	/* 14 0x0e '^N' */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x3f, 0xc0,	/* ..********.. */
	0x3f, 0xc0,	/* ..********.. */
	0x3f, 0xc0,	/* ..********.. */
	0x3f, 0xc0,	/* ..********.. */
	0x3f, 0xc0,	/* ..********.. */
	0x3f, 0xc0,	/* ..********.. */
	0x3f, 0xc0,	/* ..********.. */
	0x3f, 0xc0,	/* ..********.. */
	0x3f, 0xc0,	/* ..********.. */
	0x3f, 0xc0,	/* ..********.. */
	0x3f, 0xc0,	/* ..********.. */
	0x3f, 0xc0,	/* ..********.. */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */

	/* 15 0x0f '^O' */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x3f, 0xc0,	/* ..********.. */
	0x3f, 0xc0,	/* ..********.. */
	0x3f, 0xc0,	/* ..********.. */
	0x3f, 0xc0,	/* ..********.. */
	0x3f, 0xc0,	/* ..********.. */
	0x3f, 0xc0,	/* ..********.. */
	0x3f, 0xc0,	/* ..********.. */
	0x3f, 0xc0,	/* ..********.. */
	0x3f, 0xc0,	/* ..********.. */
	0x3f, 0xc0,	/* ..********.. */
	0x3f, 0xc0,	/* ..********.. */
	0x3f, 0xc0,	/* ..********.. */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */

	/* 16 0x10 '^P' */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x3f, 0xc0,	/* ..********.. */
	0x3f, 0xc0,	/* ..********.. */
	0x3f, 0xc0,	/* ..********.. */
	0x3f, 0xc0,	/* ..********.. */
	0x3f, 0xc0,	/* ..********.. */
	0x3f, 0xc0,	/* ..********.. */
	0x3f, 0xc0,	/* ..********.. */
	0x3f, 0xc0,	/* ..********.. */
	0x3f, 0xc0,	/* ..********.. */
	0x3f, 0xc0,	/* ..********.. */
	0x3f, 0xc0,	/* ..********.. */
	0x3f, 0xc0,	/* ..********.. */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */

	/* 17 0x11 '^Q' */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x3f, 0xc0,	/* ..********.. */
	0x3f, 0xc0,	/* ..********.. */
	0x3f, 0xc0,	/* ..********.. */
	0x3f, 0xc0,	/* ..********.. */
	0x3f, 0xc0,	/* ..********.. */
	0x3f, 0xc0,	/* ..********.. */
	0x3f, 0xc0,	/* ..********.. */
	0x3f, 0xc0,	/* ..********.. */
	0x3f, 0xc0,	/* ..********.. */
	0x3f, 0xc0,	/* ..********.. */
	0x3f, 0xc0,	/* ..********.. */
	0x3f, 0xc0,	/* ..********.. */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */

	/* 18 0x12 '^R' */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x3f, 0xc0,	/* ..********.. */
	0x3f, 0xc0,	/* ..********.. */
	0x3f, 0xc0,	/* ..********.. */
	0x3f, 0xc0,	/* ..********.. */
	0x3f, 0xc0,	/* ..********.. */
	0x3f, 0xc0,	/* ..********.. */
	0x3f, 0xc0,	/* ..********.. */
	0x3f, 0xc0,	/* ..********.. */
	0x3f, 0xc0,	/* ..********.. */
	0x3f, 0xc0,	/* ..********.. */
	0x3f, 0xc0,	/* ..********.. */
	0x3f, 0xc0,	/* ..********.. */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */

	/* 19 0x13 '^S' */
	0x00, 0x00,	/* ............ */
	0x31, 0x80,	/* ..**...**... */
	0x31, 0x80,	/* ..**...**... */
	0x31, 0x80,	/* ..**...**... */
	0x31, 0x80,	/* ..**...**... */
	0x31, 0x80,	/* ..**...**... */
	0x31, 0x80,	/* ..**...**... */
	0x31, 0x80,	/* ..**...**... */
	0x31, 0x80,	/* ..**...**... */
	0x31, 0x80,	/* ..**...**... */
	0x31, 0x80,	/* ..**...**... */
	0x31, 0x80,	/* ..**...**... */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x31, 0x80,	/* ..**...**... */
	0x31, 0x80,	/* ..**...**... */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */

	/* 20 0x14 '^T' */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x1f, 0xf0,	/* ...********* */
	0x3c, 0xc0,	/* ..****..**.. */
	0x7c, 0xc0,	/* .*****..**.. */
	0x7c, 0xc0,	/* .*****..**.. */
	0x7c, 0xc0,	/* .*****..**.. */
	0x3c, 0xc0,	/* ..****..**.. */
	0x1c, 0xc0,	/* ...***..**.. */
	0x0c, 0xc0,	/* ....**..**.. */
	0x0c, 0xc0,	/* ....**..**.. */
	0x0c, 0xc0,	/* ....**..**.. */
	0x0c, 0xc0,	/* ....**..**.. */
	0x0c, 0xc0,	/* ....**..**.. */
	0x0c, 0xc0,	/* ....**..**.. */
	0x1c, 0xe0,	/* ...***..***. */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */

	/* 21 0x15 '^U' */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x1f, 0x00,	/* ...*****.... */
	0x31, 0x80,	/* ..**...**... */
	0x31, 0x80,	/* ..**...**... */
	0x30, 0x00,	/* ..**........ */
	0x30, 0x00,	/* ..**........ */
	0x1f, 0x00,	/* ...*****.... */
	0x31, 0x80,	/* ..**...**... */
	0x31, 0x80,	/* ..**...**... */
	0x1f, 0x00,	/* ...*****.... */
	0x01, 0x80,	/* .......**... */
	0x01, 0x80,	/* .......**... */
	0x31, 0x80,	/* ..**...**... */
	0x31, 0x80,	/* ..**...**... */
	0x1f, 0x00,	/* ...*****.... */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */

	/* 22 0x16 '^V' */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x3f, 0xc0,	/* ..********.. */
	0x3f, 0xc0,	/* ..********.. */
	0x3f, 0xc0,	/* ..********.. */
	0x3f, 0xc0,	/* ..********.. */
	0x3f, 0xc0,	/* ..********.. */
	0x3f, 0xc0,	/* ..********.. */
	0x3f, 0xc0,	/* ..********.. */
	0x3f, 0xc0,	/* ..********.. */
	0x3f, 0xc0,	/* ..********.. */
	0x3f, 0xc0,	/* ..********.. */
	0x3f, 0xc0,	/* ..********.. */
	0x3f, 0xc0,	/* ..********.. */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */

	/* 23 0x17 '^W' */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x3f, 0xc0,	/* ..********.. */
	0x3f, 0xc0,	/* ..********.. */
	0x3f, 0xc0,	/* ..********.. */
	0x3f, 0xc0,	/* ..********.. */
	0x3f, 0xc0,	/* ..********.. */
	0x3f, 0xc0,	/* ..********.. */
	0x3f, 0xc0,	/* ..********.. */
	0x3f, 0xc0,	/* ..********.. */
	0x3f, 0xc0,	/* ..********.. */
	0x3f, 0xc0,	/* ..********.. */
	0x3f, 0xc0,	/* ..********.. */
	0x3f, 0xc0,	/* ..********.. */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */

	/* 24 0x18 '^X' */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x3f, 0xc0,	/* ..********.. */
	0x3f, 0xc0,	/* ..********.. */
	0x3f, 0xc0,	/* ..********.. */
	0x3f, 0xc0,	/* ..********.. */
	0x3f, 0xc0,	/* ..********.. */
	0x3f, 0xc0,	/* ..********.. */
	0x3f, 0xc0,	/* ..********.. */
	0x3f, 0xc0,	/* ..********.. */
	0x3f, 0xc0,	/* ..********.. */
	0x3f, 0xc0,	/* ..********.. */
	0x3f, 0xc0,	/* ..********.. */
	0x3f, 0xc0,	/* ..********.. */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */

	/* 25 0x19 '^Y' */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x3f, 0xc0,	/* ..********.. */
	0x3f, 0xc0,	/* ..********.. */
	0x3f, 0xc0,	/* ..********.. */
	0x3f, 0xc0,	/* ..********.. */
	0x3f, 0xc0,	/* ..********.. */
	0x3f, 0xc0,	/* ..********.. */
	0x3f, 0xc0,	/* ..********.. */
	0x3f, 0xc0,	/* ..********.. */
	0x3f, 0xc0,	/* ..********.. */
	0x3f, 0xc0,	/* ..********.. */
	0x3f, 0xc0,	/* ..********.. */
	0x3f, 0xc0,	/* ..********.. */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */

	/* 26 0x1a '^Z' */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x3f, 0xc0,	/* ..********.. */
	0x3f, 0xc0,	/* ..********.. */
	0x3f, 0xc0,	/* ..********.. */
	0x3f, 0xc0,	/* ..********.. */
	0x3f, 0xc0,	/* ..********.. */
	0x3f, 0xc0,	/* ..********.. */
	0x3f, 0xc0,	/* ..********.. */
	0x3f, 0xc0,	/* ..********.. */
	0x3f, 0xc0,	/* ..********.. */
	0x3f, 0xc0,	/* ..********.. */
	0x3f, 0xc0,	/* ..********.. */
	0x3f, 0xc0,	/* ..********.. */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */

	/* 27 0x1b '^[' */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x3f, 0xc0,	/* ..********.. */
	0x3f, 0xc0,	/* ..********.. */
	0x3f, 0xc0,	/* ..********.. */
	0x3f, 0xc0,	/* ..********.. */
	0x3f, 0xc0,	/* ..********.. */
	0x3f, 0xc0,	/* ..********.. */
	0x3f, 0xc0,	/* ..********.. */
	0x3f, 0xc0,	/* ..********.. */
	0x3f, 0xc0,	/* ..********.. */
	0x3f, 0xc0,	/* ..********.. */
	0x3f, 0xc0,	/* ..********.. */
	0x3f, 0xc0,	/* ..********.. */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */

	/* 28 0x1c '^\' */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x3f, 0xc0,	/* ..********.. */
	0x3f, 0xc0,	/* ..********.. */
	0x3f, 0xc0,	/* ..********.. */
	0x3f, 0xc0,	/* ..********.. */
	0x3f, 0xc0,	/* ..********.. */
	0x3f, 0xc0,	/* ..********.. */
	0x3f, 0xc0,	/* ..********.. */
	0x3f, 0xc0,	/* ..********.. */
	0x3f, 0xc0,	/* ..********.. */
	0x3f, 0xc0,	/* ..********.. */
	0x3f, 0xc0,	/* ..********.. */
	0x3f, 0xc0,	/* ..********.. */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */

	/* 29 0x1d '^]' */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x3f, 0xc0,	/* ..********.. */
	0x3f, 0xc0,	/* ..********.. */
	0x3f, 0xc0,	/* ..********.. */
	0x3f, 0xc0,	/* ..********.. */
	0x3f, 0xc0,	/* ..********.. */
	0x3f, 0xc0,	/* ..********.. */
	0x3f, 0xc0,	/* ..********.. */
	0x3f, 0xc0,	/* ..********.. */
	0x3f, 0xc0,	/* ..********.. */
	0x3f, 0xc0,	/* ..********.. */
	0x3f, 0xc0,	/* ..********.. */
	0x3f, 0xc0,	/* ..********.. */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */

	/* 30 0x1e '^^' */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x3f, 0xc0,	/* ..********.. */
	0x3f, 0xc0,	/* ..********.. */
	0x3f, 0xc0,	/* ..********.. */
	0x3f, 0xc0,	/* ..********.. */
	0x3f, 0xc0,	/* ..********.. */
	0x3f, 0xc0,	/* ..********.. */
	0x3f, 0xc0,	/* ..********.. */
	0x3f, 0xc0,	/* ..********.. */
	0x3f, 0xc0,	/* ..********.. */
	0x3f, 0xc0,	/* ..********.. */
	0x3f, 0xc0,	/* ..********.. */
	0x3f, 0xc0,	/* ..********.. */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */

	/* 31 0x1f '^_' */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x3f, 0xc0,	/* ..********.. */
	0x3f, 0xc0,	/* ..********.. */
	0x3f, 0xc0,	/* ..********.. */
	0x3f, 0xc0,	/* ..********.. */
	0x3f, 0xc0,	/* ..********.. */
	0x3f, 0xc0,	/* ..********.. */
	0x3f, 0xc0,	/* ..********.. */
	0x3f, 0xc0,	/* ..********.. */
	0x3f, 0xc0,	/* ..********.. */
	0x3f, 0xc0,	/* ..********.. */
	0x3f, 0xc0,	/* ..********.. */
	0x3f, 0xc0,	/* ..********.. */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */

	/* 32 0x20 ' ' */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */

	/* 33 0x21 '!' */
	0x00, 0x00,	/* ............ */
	0x06, 0x00,	/* .....**..... */
	0x06, 0x00,	/* .....**..... */
	0x06, 0x00,	/* .....**..... */
	0x06, 0x00,	/* .....**..... */
	0x06, 0x00,	/* .....**..... */
	0x06, 0x00,	/* .....**..... */
	0x06, 0x00,	/* .....**..... */
	0x06, 0x00,	/* .....**..... */
	0x06, 0x00,	/* .....**..... */
	0x06, 0x00,	/* .....**..... */
	0x06, 0x00,	/* .....**..... */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x06, 0x00,	/* .....**..... */
	0x06, 0x00,	/* .....**..... */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */

	/* 34 0x22 '"' */
	0x00, 0x00,	/* ............ */
	0x19, 0x80,	/* ...**..**... */
	0x19, 0x80,	/* ...**..**... */
	0x19, 0x80,	/* ...**..**... */
	0x19, 0x80,	/* ...**..**... */
	0x19, 0x80,	/* ...**..**... */
	0x19, 0x80,	/* ...**..**... */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */

	/* 35 0x23 '#' */
	0x00, 0x00,	/* ............ */
	0x03, 0x30,	/* ......**..** */
	0x03, 0x30,	/* ......**..** */
	0x03, 0x30,	/* ......**..** */
	0x06, 0x60,	/* .....**..**. */
	0x1f, 0xf0,	/* ...********* */
	0x1f, 0xf0,	/* ...********* */
	0x0c, 0xc0,	/* ....**..**.. */
	0x0c, 0xc0,	/* ....**..**.. */
	0x19, 0x80,	/* ...**..**... */
	0x19, 0x80,	/* ...**..**... */
	0x7f, 0xc0,	/* .*********.. */
	0x7f, 0xc0,	/* .*********.. */
	0x33, 0x00,	/* ..**..**.... */
	0x66, 0x00,	/* .**..**..... */
	0x66, 0x00,	/* .**..**..... */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */

	/* 36 0x24 '$' */
	0x00, 0x00,	/* ............ */
	0x06, 0x00,	/* .....**..... */
	0x1f, 0x80,	/* ...******... */
	0x3f, 0xc0,	/* ..********.. */
	0x66, 0xe0,	/* .**..**.***. */
	0x66, 0x60,	/* .**..**..**. */
	0x66, 0x00,	/* .**..**..... */
	0x3e, 0x00,	/* ..*****..... */
	0x1f, 0x80,	/* ...******... */
	0x07, 0xc0,	/* .....*****.. */
	0x06, 0x60,	/* .....**..**. */
	0x06, 0x60,	/* .....**..**. */
	0x66, 0x60,	/* .**..**..**. */
	0x7f, 0xc0,	/* .*********.. */
	0x3f, 0x80,	/* ..*******... */
	0x06, 0x00,	/* .....**..... */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */

	/* 37 0x25 '%' */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x38, 0xc0,	/* ..***...**.. */
	0x4c, 0xc0,	/* .*..**..**.. */
	0x45, 0x80,	/* .*...*.**... */
	0x65, 0x80,	/* .**..*.**... */
	0x3b, 0x00,	/* ..***.**.... */
	0x03, 0x00,	/* ......**.... */
	0x06, 0x00,	/* .....**..... */
	0x06, 0x00,	/* .....**..... */
	0x0c, 0x00,	/* ....**...... */
	0x0d, 0xc0,	/* ....**.***.. */
	0x1a, 0x60,	/* ...**.*..**. */
	0x1a, 0x20,	/* ...**.*...*. */
	0x33, 0x20,	/* ..**..**..*. */
	0x31, 0xc0,	/* ..**...***.. */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */

	/* 38 0x26 '&' */
	0x00, 0x00,	/* ............ */
	0x07, 0x00,	/* .....***.... */
	0x0f, 0x80,	/* ....*****... */
	0x18, 0xc0,	/* ...**...**.. */
	0x18, 0xc0,	/* ...**...**.. */
	0x18, 0xc0,	/* ...**...**.. */
	0x0f, 0x80,	/* ....*****... */
	0x1e, 0x00,	/* ...****..... */
	0x3e, 0x00,	/* ..*****..... */
	0x77, 0x00,	/* .***.***.... */
	0x63, 0x60,	/* .**...**.**. */
	0x61, 0xe0,	/* .**....****. */
	0x61, 0xc0,	/* .**....***.. */
	0x61, 0x80,	/* .**....**... */
	0x3f, 0xe0,	/* ..*********. */
	0x1e, 0x60,	/* ...****..**. */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */

	/* 39 0x27 ''' */
	0x00, 0x00,	/* ............ */
	0x0c, 0x00,	/* ....**...... */
	0x1e, 0x00,	/* ...****..... */
	0x1e, 0x00,	/* ...****..... */
	0x06, 0x00,	/* .....**..... */
	0x06, 0x00,	/* .....**..... */
	0x0c, 0x00,	/* ....**...... */
	0x18, 0x00,	/* ...**....... */
	0x10, 0x00,	/* ...*........ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */

	/* 40 0x28 '(' */
	0x00, 0x00,	/* ............ */
	0x01, 0x80,	/* .......**... */
	0x03, 0x00,	/* ......**.... */
	0x06, 0x00,	/* .....**..... */
	0x06, 0x00,	/* .....**..... */
	0x0c, 0x00,	/* ....**...... */
	0x0c, 0x00,	/* ....**...... */
	0x0c, 0x00,	/* ....**...... */
	0x0c, 0x00,	/* ....**...... */
	0x0c, 0x00,	/* ....**...... */
	0x0c, 0x00,	/* ....**...... */
	0x0c, 0x00,	/* ....**...... */
	0x06, 0x00,	/* .....**..... */
	0x06, 0x00,	/* .....**..... */
	0x03, 0x00,	/* ......**.... */
	0x01, 0x80,	/* .......**... */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */

	/* 41 0x29 ')' */
	0x00, 0x00,	/* ............ */
	0x18, 0x00,	/* ...**....... */
	0x0c, 0x00,	/* ....**...... */
	0x06, 0x00,	/* .....**..... */
	0x06, 0x00,	/* .....**..... */
	0x03, 0x00,	/* ......**.... */
	0x03, 0x00,	/* ......**.... */
	0x03, 0x00,	/* ......**.... */
	0x03, 0x00,	/* ......**.... */
	0x03, 0x00,	/* ......**.... */
	0x03, 0x00,	/* ......**.... */
	0x03, 0x00,	/* ......**.... */
	0x06, 0x00,	/* .....**..... */
	0x06, 0x00,	/* .....**..... */
	0x0c, 0x00,	/* ....**...... */
	0x18, 0x00,	/* ...**....... */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */

	/* 42 0x2a '*' */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x0f, 0x00,	/* ....****.... */
	0x06, 0x00,	/* .....**..... */
	0x66, 0x60,	/* .**..**..**. */
	0x76, 0xe0,	/* .***.**.***. */
	0x19, 0x80,	/* ...**..**... */
	0x00, 0x00,	/* ............ */
	0x19, 0x80,	/* ...**..**... */
	0x76, 0xe0,	/* .***.**.***. */
	0x66, 0x60,	/* .**..**..**. */
	0x06, 0x00,	/* .....**..... */
	0x0f, 0x00,	/* ....****.... */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */

	/* 43 0x2b '+' */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x06, 0x00,	/* .....**..... */
	0x06, 0x00,	/* .....**..... */
	0x06, 0x00,	/* .....**..... */
	0x06, 0x00,	/* .....**..... */
	0x7f, 0xe0,	/* .**********. */
	0x7f, 0xe0,	/* .**********. */
	0x06, 0x00,	/* .....**..... */
	0x06, 0x00,	/* .....**..... */
	0x06, 0x00,	/* .....**..... */
	0x06, 0x00,	/* .....**..... */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */

	/* 44 0x2c ',' */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x0c, 0x00,	/* ....**...... */
	0x1e, 0x00,	/* ...****..... */
	0x1e, 0x00,	/* ...****..... */
	0x06, 0x00,	/* .....**..... */
	0x06, 0x00,	/* .....**..... */
	0x0c, 0x00,	/* ....**...... */
	0x18, 0x00,	/* ...**....... */
	0x10, 0x00,	/* ...*........ */
	0x00, 0x00,	/* ............ */

	/* 45 0x2d '-' */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x7f, 0xe0,	/* .**********. */
	0x7f, 0xe0,	/* .**********. */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */

	/* 46 0x2e '.' */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x0c, 0x00,	/* ....**...... */
	0x1e, 0x00,	/* ...****..... */
	0x1e, 0x00,	/* ...****..... */
	0x0c, 0x00,	/* ....**...... */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */

	/* 47 0x2f '/' */
	0x00, 0x00,	/* ............ */
	0x00, 0x60,	/* .........**. */
	0x00, 0xc0,	/* ........**.. */
	0x00, 0xc0,	/* ........**.. */
	0x01, 0x80,	/* .......**... */
	0x01, 0x80,	/* .......**... */
	0x03, 0x00,	/* ......**.... */
	0x03, 0x00,	/* ......**.... */
	0x06, 0x00,	/* .....**..... */
	0x06, 0x00,	/* .....**..... */
	0x0c, 0x00,	/* ....**...... */
	0x0c, 0x00,	/* ....**...... */
	0x18, 0x00,	/* ...**....... */
	0x18, 0x00,	/* ...**....... */
	0x30, 0x00,	/* ..**........ */
	0x30, 0x00,	/* ..**........ */
	0x60, 0x00,	/* .**......... */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */

	/* 48 0x30 '0' */
	0x00, 0x00,	/* ............ */
	0x07, 0x00,	/* .....***.... */
	0x0f, 0x80,	/* ....*****... */
	0x11, 0x80,	/* ...*...**... */
	0x10, 0xc0,	/* ...*....**.. */
	0x30, 0xc0,	/* ..**....**.. */
	0x30, 0xc0,	/* ..**....**.. */
	0x30, 0xc0,	/* ..**....**.. */
	0x30, 0xc0,	/* ..**....**.. */
	0x30, 0xc0,	/* ..**....**.. */
	0x30, 0xc0,	/* ..**....**.. */
	0x30, 0xc0,	/* ..**....**.. */
	0x30, 0x80,	/* ..**....*... */
	0x18, 0x80,	/* ...**...*... */
	0x1f, 0x00,	/* ...*****.... */
	0x0e, 0x00,	/* ....***..... */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */

	/* 49 0x31 '1' */
	0x00, 0x00,	/* ............ */
	0x02, 0x00,	/* ......*..... */
	0x06, 0x00,	/* .....**..... */
	0x0e, 0x00,	/* ....***..... */
	0x1e, 0x00,	/* ...****..... */
	0x36, 0x00,	/* ..**.**..... */
	0x06, 0x00,	/* .....**..... */
	0x06, 0x00,	/* .....**..... */
	0x06, 0x00,	/* .....**..... */
	0x06, 0x00,	/* .....**..... */
	0x06, 0x00,	/* .....**..... */
	0x06, 0x00,	/* .....**..... */
	0x06, 0x00,	/* .....**..... */
	0x06, 0x00,	/* .....**..... */
	0x06, 0x00,	/* .....**..... */
	0x3f, 0xc0,	/* ..********.. */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */

	/* 50 0x32 '2' */
	0x00, 0x00,	/* ............ */
	0x1f, 0x00,	/* ...*****.... */
	0x3f, 0x80,	/* ..*******... */
	0x61, 0xc0,	/* .**....***.. */
	0x40, 0xc0,	/* .*......**.. */
	0x00, 0xc0,	/* ........**.. */
	0x00, 0xc0,	/* ........**.. */
	0x00, 0xc0,	/* ........**.. */
	0x01, 0x80,	/* .......**... */
	0x03, 0x00,	/* ......**.... */
	0x06, 0x00,	/* .....**..... */
	0x0c, 0x00,	/* ....**...... */
	0x18, 0x00,	/* ...**....... */
	0x30, 0x20,	/* ..**......*. */
	0x7f, 0xe0,	/* .**********. */
	0x7f, 0xe0,	/* .**********. */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */

	/* 51 0x33 '3' */
	0x00, 0x00,	/* ............ */
	0x0f, 0x80,	/* ....*****... */
	0x1f, 0xc0,	/* ...*******.. */
	0x20, 0xe0,	/* ..*.....***. */
	0x40, 0x60,	/* .*.......**. */
	0x00, 0x60,	/* .........**. */
	0x00, 0xe0,	/* ........***. */
	0x07, 0xc0,	/* .....*****.. */
	0x0f, 0xc0,	/* ....******.. */
	0x00, 0xe0,	/* ........***. */
	0x00, 0x60,	/* .........**. */
	0x00, 0x60,	/* .........**. */
	0x40, 0x60,	/* .*.......**. */
	0x60, 0x40,	/* .**......*.. */
	0x3f, 0x80,	/* ..*******... */
	0x1f, 0x00,	/* ...*****.... */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */

	/* 52 0x34 '4' */
	0x00, 0x00,	/* ............ */
	0x01, 0x80,	/* .......**... */
	0x03, 0x80,	/* ......***... */
	0x03, 0x80,	/* ......***... */
	0x05, 0x80,	/* .....*.**... */
	0x05, 0x80,	/* .....*.**... */
	0x09, 0x80,	/* ....*..**... */
	0x09, 0x80,	/* ....*..**... */
	0x11, 0x80,	/* ...*...**... */
	0x11, 0x80,	/* ...*...**... */
	0x21, 0x80,	/* ..*....**... */
	0x3f, 0xe0,	/* ..*********. */
	0x7f, 0xe0,	/* .**********. */
	0x01, 0x80,	/* .......**... */
	0x01, 0x80,	/* .......**... */
	0x01, 0x80,	/* .......**... */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */

	/* 53 0x35 '5' */
	0x00, 0x00,	/* ............ */
	0x0f, 0xc0,	/* ....******.. */
	0x0f, 0xc0,	/* ....******.. */
	0x10, 0x00,	/* ...*........ */
	0x10, 0x00,	/* ...*........ */
	0x20, 0x00,	/* ..*......... */
	0x3f, 0x80,	/* ..*******... */
	0x31, 0xc0,	/* ..**...***.. */
	0x00, 0xe0,	/* ........***. */
	0x00, 0x60,	/* .........**. */
	0x00, 0x60,	/* .........**. */
	0x00, 0x60,	/* .........**. */
	0x40, 0x60,	/* .*.......**. */
	0x60, 0x60,	/* .**......**. */
	0x30, 0xc0,	/* ..**....**.. */
	0x1f, 0x80,	/* ...******... */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */

	/* 54 0x36 '6' */
	0x00, 0x00,	/* ............ */
	0x07, 0x00,	/* .....***.... */
	0x0c, 0x00,	/* ....**...... */
	0x18, 0x00,	/* ...**....... */
	0x30, 0x00,	/* ..**........ */
	0x30, 0x00,	/* ..**........ */
	0x60, 0x00,	/* .**......... */
	0x67, 0x80,	/* .**..****... */
	0x6f, 0xc0,	/* .**.******.. */
	0x70, 0xe0,	/* .***....***. */
	0x60, 0x60,	/* .**......**. */
	0x60, 0x60,	/* .**......**. */
	0x60, 0x60,	/* .**......**. */
	0x70, 0x40,	/* .***.....*.. */
	0x3f, 0x80,	/* ..*******... */
	0x1f, 0x00,	/* ...*****.... */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */

	/* 55 0x37 '7' */
	0x00, 0x00,	/* ............ */
	0x1f, 0xe0,	/* ...********. */
	0x3f, 0xe0,	/* ..*********. */
	0x60, 0x40,	/* .**......*.. */
	0x00, 0x40,	/* .........*.. */
	0x00, 0xc0,	/* ........**.. */
	0x00, 0x80,	/* ........*... */
	0x00, 0x80,	/* ........*... */
	0x01, 0x80,	/* .......**... */
	0x01, 0x00,	/* .......*.... */
	0x01, 0x00,	/* .......*.... */
	0x03, 0x00,	/* ......**.... */
	0x02, 0x00,	/* ......*..... */
	0x02, 0x00,	/* ......*..... */
	0x06, 0x00,	/* .....**..... */
	0x04, 0x00,	/* .....*...... */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */

	/* 56 0x38 '8' */
	0x00, 0x00,	/* ............ */
	0x0f, 0x00,	/* ....****.... */
	0x11, 0x80,	/* ...*...**... */
	0x30, 0xc0,	/* ..**....**.. */
	0x30, 0xc0,	/* ..**....**.. */
	0x30, 0xc0,	/* ..**....**.. */
	0x18, 0x80,	/* ...**...*... */
	0x0d, 0x00,	/* ....**.*.... */
	0x06, 0x00,	/* .....**..... */
	0x0b, 0x00,	/* ....*.**.... */
	0x11, 0x80,	/* ...*...**... */
	0x30, 0xc0,	/* ..**....**.. */
	0x30, 0xc0,	/* ..**....**.. */
	0x30, 0xc0,	/* ..**....**.. */
	0x18, 0x80,	/* ...**...*... */
	0x0f, 0x00,	/* ....****.... */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */

	/* 57 0x39 '9' */
	0x00, 0x00,	/* ............ */
	0x0f, 0x80,	/* ....*****... */
	0x11, 0xc0,	/* ...*...***.. */
	0x20, 0xe0,	/* ..*.....***. */
	0x60, 0x60,	/* .**......**. */
	0x60, 0x60,	/* .**......**. */
	0x60, 0x60,	/* .**......**. */
	0x70, 0xe0,	/* .***....***. */
	0x3f, 0x60,	/* ..******.**. */
	0x1e, 0x60,	/* ...****..**. */
	0x00, 0x60,	/* .........**. */
	0x00, 0xc0,	/* ........**.. */
	0x00, 0xc0,	/* ........**.. */
	0x01, 0x80,	/* .......**... */
	0x07, 0x00,	/* .....***.... */
	0x3c, 0x00,	/* ..****...... */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */

	/* 58 0x3a ':' */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x0c, 0x00,	/* ....**...... */
	0x1e, 0x00,	/* ...****..... */
	0x1e, 0x00,	/* ...****..... */
	0x0c, 0x00,	/* ....**...... */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x0c, 0x00,	/* ....**...... */
	0x1e, 0x00,	/* ...****..... */
	0x1e, 0x00,	/* ...****..... */
	0x0c, 0x00,	/* ....**...... */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */

	/* 59 0x3b ';' */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x0c, 0x00,	/* ....**...... */
	0x1e, 0x00,	/* ...****..... */
	0x1e, 0x00,	/* ...****..... */
	0x0c, 0x00,	/* ....**...... */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x0c, 0x00,	/* ....**...... */
	0x1e, 0x00,	/* ...****..... */
	0x1e, 0x00,	/* ...****..... */
	0x06, 0x00,	/* .....**..... */
	0x06, 0x00,	/* .....**..... */
	0x0c, 0x00,	/* ....**...... */
	0x18, 0x00,	/* ...**....... */
	0x10, 0x00,	/* ...*........ */
	0x00, 0x00,	/* ............ */

	/* 60 0x3c '<' */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x60,	/* .........**. */
	0x01, 0xc0,	/* .......***.. */
	0x07, 0x00,	/* .....***.... */
	0x1c, 0x00,	/* ...***...... */
	0x70, 0x00,	/* .***........ */
	0x70, 0x00,	/* .***........ */
	0x1c, 0x00,	/* ...***...... */
	0x07, 0x00,	/* .....***.... */
	0x01, 0xc0,	/* .......***.. */
	0x00, 0x60,	/* .........**. */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */

	/* 61 0x3d '=' */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x7f, 0xe0,	/* .**********. */
	0x7f, 0xe0,	/* .**********. */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x7f, 0xe0,	/* .**********. */
	0x7f, 0xe0,	/* .**********. */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */

	/* 62 0x3e '>' */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x60, 0x00,	/* .**......... */
	0x38, 0x00,	/* ..***....... */
	0x0e, 0x00,	/* ....***..... */
	0x03, 0x80,	/* ......***... */
	0x00, 0xe0,	/* ........***. */
	0x00, 0xe0,	/* ........***. */
	0x03, 0x80,	/* ......***... */
	0x0e, 0x00,	/* ....***..... */
	0x38, 0x00,	/* ..***....... */
	0x60, 0x00,	/* .**......... */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */

	/* 63 0x3f '?' */
	0x00, 0x00,	/* ............ */
	0x0f, 0x00,	/* ....****.... */
	0x1f, 0x80,	/* ...******... */
	0x39, 0xc0,	/* ..***..***.. */
	0x20, 0xc0,	/* ..*.....**.. */
	0x00, 0xc0,	/* ........**.. */
	0x00, 0xc0,	/* ........**.. */
	0x01, 0x80,	/* .......**... */
	0x03, 0x00,	/* ......**.... */
	0x06, 0x00,	/* .....**..... */
	0x0c, 0x00,	/* ....**...... */
	0x0c, 0x00,	/* ....**...... */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x0c, 0x00,	/* ....**...... */
	0x0c, 0x00,	/* ....**...... */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */

	/* 64 0x40 '@' */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x0f, 0x80,	/* ....*****... */
	0x3f, 0xc0,	/* ..********.. */
	0x30, 0x60,	/* ..**.....**. */
	0x60, 0x60,	/* .**......**. */
	0x67, 0x20,	/* .**..***..*. */
	0x6f, 0xa0,	/* .**.*****.*. */
	0x6c, 0xa0,	/* .**.**..*.*. */
	0x6c, 0xa0,	/* .**.**..*.*. */
	0x67, 0xe0,	/* .**..******. */
	0x60, 0x00,	/* .**......... */
	0x30, 0x00,	/* ..**........ */
	0x3f, 0xe0,	/* ..*********. */
	0x0f, 0xe0,	/* ....*******. */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */

	/* 65 0x41 'A' */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x06, 0x00,	/* .....**..... */
	0x06, 0x00,	/* .....**..... */
	0x0b, 0x00,	/* ....*.**.... */
	0x0b, 0x00,	/* ....*.**.... */
	0x09, 0x00,	/* ....*..*.... */
	0x11, 0x80,	/* ...*...**... */
	0x11, 0x80,	/* ...*...**... */
	0x10, 0x80,	/* ...*....*... */
	0x3f, 0xc0,	/* ..********.. */
	0x20, 0xc0,	/* ..*.....**.. */
	0x20, 0x40,	/* ..*......*.. */
	0x40, 0x60,	/* .*.......**. */
	0x40, 0x60,	/* .*.......**. */
	0xe0, 0xf0,	/* ***.....**** */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */

	/* 66 0x42 'B' */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0xff, 0x00,	/* ********.... */
	0x60, 0x80,	/* .**.....*... */
	0x60, 0xc0,	/* .**.....**.. */
	0x60, 0xc0,	/* .**.....**.. */
	0x60, 0xc0,	/* .**.....**.. */
	0x61, 0x80,	/* .**....**... */
	0x7f, 0x80,	/* .********... */
	0x60, 0xc0,	/* .**.....**.. */
	0x60, 0x60,	/* .**......**. */
	0x60, 0x60,	/* .**......**. */
	0x60, 0x60,	/* .**......**. */
	0x60, 0x60,	/* .**......**. */
	0x60, 0xc0,	/* .**.....**.. */
	0xff, 0x80,	/* *********... */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */

	/* 67 0x43 'C' */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x0f, 0xc0,	/* ....******.. */
	0x10, 0x60,	/* ...*.....**. */
	0x20, 0x20,	/* ..*.......*. */
	0x20, 0x00,	/* ..*......... */
	0x60, 0x00,	/* .**......... */
	0x60, 0x00,	/* .**......... */
	0x60, 0x00,	/* .**......... */
	0x60, 0x00,	/* .**......... */
	0x60, 0x00,	/* .**......... */
	0x60, 0x00,	/* .**......... */
	0x20, 0x00,	/* ..*......... */
	0x30, 0x20,	/* ..**......*. */
	0x18, 0x40,	/* ...**....*.. */
	0x0f, 0x80,	/* ....*****... */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */

	/* 68 0x44 'D' */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0xff, 0x00,	/* ********.... */
	0x61, 0xc0,	/* .**....***.. */
	0x60, 0xc0,	/* .**.....**.. */
	0x60, 0x60,	/* .**......**. */
	0x60, 0x60,	/* .**......**. */
	0x60, 0x60,	/* .**......**. */
	0x60, 0x60,	/* .**......**. */
	0x60, 0x60,	/* .**......**. */
	0x60, 0x60,	/* .**......**. */
	0x60, 0x60,	/* .**......**. */
	0x60, 0x60,	/* .**......**. */
	0x60, 0x40,	/* .**......*.. */
	0x61, 0x80,	/* .**....**... */
	0xfe, 0x00,	/* *******..... */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */

	/* 69 0x45 'E' */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x7f, 0xc0,	/* .*********.. */
	0x30, 0x40,	/* ..**.....*.. */
	0x30, 0x40,	/* ..**.....*.. */
	0x30, 0x00,	/* ..**........ */
	0x30, 0x00,	/* ..**........ */
	0x30, 0x80,	/* ..**....*... */
	0x3f, 0x80,	/* ..*******... */
	0x30, 0x80,	/* ..**....*... */
	0x30, 0x00,	/* ..**........ */
	0x30, 0x00,	/* ..**........ */
	0x30, 0x00,	/* ..**........ */
	0x30, 0x20,	/* ..**......*. */
	0x30, 0x20,	/* ..**......*. */
	0x7f, 0xe0,	/* .**********. */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */

	/* 70 0x46 'F' */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x7f, 0xc0,	/* .*********.. */
	0x30, 0x40,	/* ..**.....*.. */
	0x30, 0x40,	/* ..**.....*.. */
	0x30, 0x00,	/* ..**........ */
	0x30, 0x00,	/* ..**........ */
	0x30, 0x80,	/* ..**....*... */
	0x3f, 0x80,	/* ..*******... */
	0x30, 0x80,	/* ..**....*... */
	0x30, 0x00,	/* ..**........ */
	0x30, 0x00,	/* ..**........ */
	0x30, 0x00,	/* ..**........ */
	0x30, 0x00,	/* ..**........ */
	0x30, 0x00,	/* ..**........ */
	0x78, 0x00,	/* .****....... */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */

	/* 71 0x47 'G' */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x0f, 0xc0,	/* ....******.. */
	0x10, 0x60,	/* ...*.....**. */
	0x20, 0x20,	/* ..*.......*. */
	0x20, 0x00,	/* ..*......... */
	0x60, 0x00,	/* .**......... */
	0x60, 0x00,	/* .**......... */
	0x60, 0x00,	/* .**......... */
	0x60, 0x00,	/* .**......... */
	0x61, 0xf0,	/* .**....***** */
	0x60, 0x60,	/* .**......**. */
	0x20, 0x60,	/* ..*......**. */
	0x30, 0x60,	/* ..**.....**. */
	0x18, 0x60,	/* ...**....**. */
	0x0f, 0x80,	/* ....*****... */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */

	/* 72 0x48 'H' */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0xf0, 0xf0,	/* ****....**** */
	0x60, 0x60,	/* .**......**. */
	0x60, 0x60,	/* .**......**. */
	0x60, 0x60,	/* .**......**. */
	0x60, 0x60,	/* .**......**. */
	0x60, 0x60,	/* .**......**. */
	0x7f, 0xe0,	/* .**********. */
	0x60, 0x60,	/* .**......**. */
	0x60, 0x60,	/* .**......**. */
	0x60, 0x60,	/* .**......**. */
	0x60, 0x60,	/* .**......**. */
	0x60, 0x60,	/* .**......**. */
	0x60, 0x60,	/* .**......**. */
	0xf0, 0xf0,	/* ****....**** */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */

	/* 73 0x49 'I' */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x1f, 0x80,	/* ...******... */
	0x06, 0x00,	/* .....**..... */
	0x06, 0x00,	/* .....**..... */
	0x06, 0x00,	/* .....**..... */
	0x06, 0x00,	/* .....**..... */
	0x06, 0x00,	/* .....**..... */
	0x06, 0x00,	/* .....**..... */
	0x06, 0x00,	/* .....**..... */
	0x06, 0x00,	/* .....**..... */
	0x06, 0x00,	/* .....**..... */
	0x06, 0x00,	/* .....**..... */
	0x06, 0x00,	/* .....**..... */
	0x06, 0x00,	/* .....**..... */
	0x1f, 0x80,	/* ...******... */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */

	/* 74 0x4a 'J' */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x1f, 0x80,	/* ...******... */
	0x06, 0x00,	/* .....**..... */
	0x06, 0x00,	/* .....**..... */
	0x06, 0x00,	/* .....**..... */
	0x06, 0x00,	/* .....**..... */
	0x06, 0x00,	/* .....**..... */
	0x06, 0x00,	/* .....**..... */
	0x06, 0x00,	/* .....**..... */
	0x06, 0x00,	/* .....**..... */
	0x06, 0x00,	/* .....**..... */
	0x06, 0x00,	/* .....**..... */
	0x06, 0x00,	/* .....**..... */
	0x06, 0x00,	/* .....**..... */
	0x06, 0x00,	/* .....**..... */
	0x06, 0x00,	/* .....**..... */
	0x06, 0x00,	/* .....**..... */
	0x04, 0x00,	/* .....*...... */
	0x38, 0x00,	/* ..***....... */
	0x30, 0x00,	/* ..**........ */
	0x00, 0x00,	/* ............ */

	/* 75 0x4b 'K' */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0xf0, 0xe0,	/* ****....***. */
	0x61, 0x80,	/* .**....**... */
	0x63, 0x00,	/* .**...**.... */
	0x66, 0x00,	/* .**..**..... */
	0x6c, 0x00,	/* .**.**...... */
	0x78, 0x00,	/* .****....... */
	0x78, 0x00,	/* .****....... */
	0x7c, 0x00,	/* .*****...... */
	0x6e, 0x00,	/* .**.***..... */
	0x67, 0x00,	/* .**..***.... */
	0x63, 0x80,	/* .**...***... */
	0x61, 0xc0,	/* .**....***.. */
	0x60, 0xe0,	/* .**.....***. */
	0xf0, 0x70,	/* ****.....*** */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */

	/* 76 0x4c 'L' */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x78, 0x00,	/* .****....... */
	0x30, 0x00,	/* ..**........ */
	0x30, 0x00,	/* ..**........ */
	0x30, 0x00,	/* ..**........ */
	0x30, 0x00,	/* ..**........ */
	0x30, 0x00,	/* ..**........ */
	0x30, 0x00,	/* ..**........ */
	0x30, 0x00,	/* ..**........ */
	0x30, 0x00,	/* ..**........ */
	0x30, 0x00,	/* ..**........ */
	0x30, 0x00,	/* ..**........ */
	0x30, 0x20,	/* ..**......*. */
	0x30, 0x20,	/* ..**......*. */
	0x7f, 0xe0,	/* .**********. */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */

	/* 77 0x4d 'M' */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0xe0, 0x70,	/* ***......*** */
	0x60, 0xe0,	/* .**.....***. */
	0x70, 0xe0,	/* .***....***. */
	0x70, 0xe0,	/* .***....***. */
	0x70, 0xe0,	/* .***....***. */
	0x59, 0x60,	/* .*.**..*.**. */
	0x59, 0x60,	/* .*.**..*.**. */
	0x59, 0x60,	/* .*.**..*.**. */
	0x4d, 0x60,	/* .*..**.*.**. */
	0x4e, 0x60,	/* .*..***..**. */
	0x4e, 0x60,	/* .*..***..**. */
	0x44, 0x60,	/* .*...*...**. */
	0x44, 0x60,	/* .*...*...**. */
	0xe4, 0xf0,	/* ***..*..**** */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */

	/* 78 0x4e 'N' */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0xc0, 0x70,	/* **.......*** */
	0x60, 0x20,	/* .**.......*. */
	0x70, 0x20,	/* .***......*. */
	0x78, 0x20,	/* .****.....*. */
	0x58, 0x20,	/* .*.**.....*. */
	0x4c, 0x20,	/* .*..**....*. */
	0x46, 0x20,	/* .*...**...*. */
	0x47, 0x20,	/* .*...***..*. */
	0x43, 0x20,	/* .*....**..*. */
	0x41, 0xa0,	/* .*.....**.*. */
	0x40, 0xe0,	/* .*......***. */
	0x40, 0xe0,	/* .*......***. */
	0x40, 0x60,	/* .*.......**. */
	0xe0, 0x30,	/* ***.......** */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */

	/* 79 0x4f 'O' */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x0f, 0x00,	/* ....****.... */
	0x11, 0xc0,	/* ...*...***.. */
	0x20, 0xc0,	/* ..*.....**.. */
	0x20, 0x60,	/* ..*......**. */
	0x60, 0x60,	/* .**......**. */
	0x60, 0x60,	/* .**......**. */
	0x60, 0x60,	/* .**......**. */
	0x60, 0x60,	/* .**......**. */
	0x60, 0x60,	/* .**......**. */
	0x60, 0x60,	/* .**......**. */
	0x20, 0x40,	/* ..*......*.. */
	0x30, 0x40,	/* ..**.....*.. */
	0x18, 0x80,	/* ...**...*... */
	0x0f, 0x00,	/* ....****.... */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */

	/* 80 0x50 'P' */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x7f, 0x80,	/* .********... */
	0x30, 0xc0,	/* ..**....**.. */
	0x30, 0x60,	/* ..**.....**. */
	0x30, 0x60,	/* ..**.....**. */
	0x30, 0x60,	/* ..**.....**. */
	0x30, 0xc0,	/* ..**....**.. */
	0x37, 0x80,	/* ..**.****... */
	0x30, 0x00,	/* ..**........ */
	0x30, 0x00,	/* ..**........ */
	0x30, 0x00,	/* ..**........ */
	0x30, 0x00,	/* ..**........ */
	0x30, 0x00,	/* ..**........ */
	0x30, 0x00,	/* ..**........ */
	0x78, 0x00,	/* .****....... */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */

	/* 81 0x51 'Q' */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x0f, 0x00,	/* ....****.... */
	0x11, 0xc0,	/* ...*...***.. */
	0x20, 0xc0,	/* ..*.....**.. */
	0x20, 0x60,	/* ..*......**. */
	0x60, 0x60,	/* .**......**. */
	0x60, 0x60,	/* .**......**. */
	0x60, 0x60,	/* .**......**. */
	0x60, 0x60,	/* .**......**. */
	0x60, 0x60,	/* .**......**. */
	0x60, 0x60,	/* .**......**. */
	0x30, 0x40,	/* ..**.....*.. */
	0x38, 0x40,	/* ..***....*.. */
	0x1f, 0x80,	/* ...******... */
	0x0e, 0x00,	/* ....***..... */
	0x1f, 0x00,	/* ...*****.... */
	0x23, 0x90,	/* ..*...***..* */
	0x01, 0xe0,	/* .......****. */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */

	/* 82 0x52 'R' */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0xff, 0x00,	/* ********.... */
	0x61, 0x80,	/* .**....**... */
	0x60, 0xc0,	/* .**.....**.. */
	0x60, 0xc0,	/* .**.....**.. */
	0x60, 0xc0,	/* .**.....**.. */
	0x60, 0x80,	/* .**.....*... */
	0x7f, 0x00,	/* .*******.... */
	0x7c, 0x00,	/* .*****...... */
	0x6e, 0x00,	/* .**.***..... */
	0x67, 0x00,	/* .**..***.... */
	0x63, 0x80,	/* .**...***... */
	0x61, 0xc0,	/* .**....***.. */
	0x60, 0xe0,	/* .**.....***. */
	0xf0, 0x70,	/* ****.....*** */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */

	/* 83 0x53 'S' */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x1f, 0xe0,	/* ...********. */
	0x30, 0x60,	/* ..**.....**. */
	0x60, 0x20,	/* .**.......*. */
	0x60, 0x20,	/* .**.......*. */
	0x70, 0x00,	/* .***........ */
	0x3c, 0x00,	/* ..****...... */
	0x1e, 0x00,	/* ...****..... */
	0x07, 0x80,	/* .....****... */
	0x01, 0xc0,	/* .......***.. */
	0x00, 0xe0,	/* ........***. */
	0x40, 0x60,	/* .*.......**. */
	0x40, 0x60,	/* .*.......**. */
	0x60, 0xc0,	/* .**.....**.. */
	0x7f, 0x80,	/* .********... */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */

	/* 84 0x54 'T' */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x7f, 0xe0,	/* .**********. */
	0x46, 0x20,	/* .*...**...*. */
	0x06, 0x00,	/* .....**..... */
	0x06, 0x00,	/* .....**..... */
	0x06, 0x00,	/* .....**..... */
	0x06, 0x00,	/* .....**..... */
	0x06, 0x00,	/* .....**..... */
	0x06, 0x00,	/* .....**..... */
	0x06, 0x00,	/* .....**..... */
	0x06, 0x00,	/* .....**..... */
	0x06, 0x00,	/* .....**..... */
	0x06, 0x00,	/* .....**..... */
	0x06, 0x00,	/* .....**..... */
	0x1f, 0x80,	/* ...******... */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */

	/* 85 0x55 'U' */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0xf0, 0x70,	/* ****.....*** */
	0x60, 0x20,	/* .**.......*. */
	0x60, 0x20,	/* .**.......*. */
	0x60, 0x20,	/* .**.......*. */
	0x60, 0x20,	/* .**.......*. */
	0x60, 0x20,	/* .**.......*. */
	0x60, 0x20,	/* .**.......*. */
	0x60, 0x20,	/* .**.......*. */
	0x60, 0x20,	/* .**.......*. */
	0x60, 0x20,	/* .**.......*. */
	0x60, 0x20,	/* .**.......*. */
	0x70, 0x40,	/* .***.....*.. */
	0x3f, 0xc0,	/* ..********.. */
	0x1f, 0x80,	/* ...******... */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */

	/* 86 0x56 'V' */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0xe0, 0xe0,	/* ***.....***. */
	0x60, 0x40,	/* .**......*.. */
	0x30, 0x80,	/* ..**....*... */
	0x30, 0x80,	/* ..**....*... */
	0x30, 0x80,	/* ..**....*... */
	0x19, 0x00,	/* ...**..*.... */
	0x19, 0x00,	/* ...**..*.... */
	0x19, 0x00,	/* ...**..*.... */
	0x0a, 0x00,	/* ....*.*..... */
	0x0e, 0x00,	/* ....***..... */
	0x0e, 0x00,	/* ....***..... */
	0x04, 0x00,	/* .....*...... */
	0x04, 0x00,	/* .....*...... */
	0x04, 0x00,	/* .....*...... */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */

	/* 87 0x57 'W' */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0xfe, 0xf0,	/* *******.**** */
	0x66, 0x20,	/* .**..**...*. */
	0x66, 0x20,	/* .**..**...*. */
	0x66, 0x20,	/* .**..**...*. */
	0x76, 0x20,	/* .***.**...*. */
	0x77, 0x40,	/* .***.***.*.. */
	0x33, 0x40,	/* ..**..**.*.. */
	0x37, 0x40,	/* ..**.***.*.. */
	0x3b, 0xc0,	/* ..***.****.. */
	0x3b, 0x80,	/* ..***.***... */
	0x19, 0x80,	/* ...**..**... */
	0x19, 0x80,	/* ...**..**... */
	0x19, 0x80,	/* ...**..**... */
	0x19, 0x80,	/* ...**..**... */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */

	/* 88 0x58 'X' */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0xf0, 0x70,	/* ****.....*** */
	0x60, 0x20,	/* .**.......*. */
	0x30, 0x40,	/* ..**.....*.. */
	0x38, 0x80,	/* ..***...*... */
	0x18, 0x80,	/* ...**...*... */
	0x0d, 0x00,	/* ....**.*.... */
	0x06, 0x00,	/* .....**..... */
	0x06, 0x00,	/* .....**..... */
	0x0b, 0x00,	/* ....*.**.... */
	0x11, 0x80,	/* ...*...**... */
	0x11, 0xc0,	/* ...*...***.. */
	0x20, 0xc0,	/* ..*.....**.. */
	0x40, 0x60,	/* .*.......**. */
	0xe0, 0xf0,	/* ***.....**** */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */

	/* 89 0x59 'Y' */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0xf0, 0x70,	/* ****.....*** */
	0x60, 0x20,	/* .**.......*. */
	0x30, 0x40,	/* ..**.....*.. */
	0x18, 0x80,	/* ...**...*... */
	0x18, 0x80,	/* ...**...*... */
	0x0d, 0x00,	/* ....**.*.... */
	0x06, 0x00,	/* .....**..... */
	0x06, 0x00,	/* .....**..... */
	0x06, 0x00,	/* .....**..... */
	0x06, 0x00,	/* .....**..... */
	0x06, 0x00,	/* .....**..... */
	0x06, 0x00,	/* .....**..... */
	0x06, 0x00,	/* .....**..... */
	0x0f, 0x00,	/* ....****.... */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */

	/* 90 0x5a 'Z' */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x3f, 0xe0,	/* ..*********. */
	0x20, 0xc0,	/* ..*.....**.. */
	0x00, 0xc0,	/* ........**.. */
	0x01, 0x80,	/* .......**... */
	0x01, 0x80,	/* .......**... */
	0x03, 0x00,	/* ......**.... */
	0x03, 0x00,	/* ......**.... */
	0x06, 0x00,	/* .....**..... */
	0x06, 0x00,	/* .....**..... */
	0x0c, 0x00,	/* ....**...... */
	0x0c, 0x00,	/* ....**...... */
	0x18, 0x00,	/* ...**....... */
	0x18, 0x20,	/* ...**.....*. */
	0x3f, 0xe0,	/* ..*********. */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */

	/* 91 0x5b '[' */
	0x00, 0x00,	/* ............ */
	0x0f, 0x80,	/* ....*****... */
	0x0f, 0x80,	/* ....*****... */
	0x0c, 0x00,	/* ....**...... */
	0x0c, 0x00,	/* ....**...... */
	0x0c, 0x00,	/* ....**...... */
	0x0c, 0x00,	/* ....**...... */
	0x0c, 0x00,	/* ....**...... */
	0x0c, 0x00,	/* ....**...... */
	0x0c, 0x00,	/* ....**...... */
	0x0c, 0x00,	/* ....**...... */
	0x0c, 0x00,	/* ....**...... */
	0x0c, 0x00,	/* ....**...... */
	0x0c, 0x00,	/* ....**...... */
	0x0f, 0x80,	/* ....*****... */
	0x0f, 0x80,	/* ....*****... */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */

	/* 92 0x5c '\' */
	0x00, 0x00,	/* ............ */
	0x60, 0x00,	/* .**......... */
	0x30, 0x00,	/* ..**........ */
	0x30, 0x00,	/* ..**........ */
	0x18, 0x00,	/* ...**....... */
	0x18, 0x00,	/* ...**....... */
	0x0c, 0x00,	/* ....**...... */
	0x0c, 0x00,	/* ....**...... */
	0x06, 0x00,	/* .....**..... */
	0x06, 0x00,	/* .....**..... */
	0x03, 0x00,	/* ......**.... */
	0x03, 0x00,	/* ......**.... */
	0x01, 0x80,	/* .......**... */
	0x01, 0x80,	/* .......**... */
	0x00, 0xc0,	/* ........**.. */
	0x00, 0xc0,	/* ........**.. */
	0x00, 0x60,	/* .........**. */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */

	/* 93 0x5d ']' */
	0x00, 0x00,	/* ............ */
	0x1f, 0x00,	/* ...*****.... */
	0x1f, 0x00,	/* ...*****.... */
	0x03, 0x00,	/* ......**.... */
	0x03, 0x00,	/* ......**.... */
	0x03, 0x00,	/* ......**.... */
	0x03, 0x00,	/* ......**.... */
	0x03, 0x00,	/* ......**.... */
	0x03, 0x00,	/* ......**.... */
	0x03, 0x00,	/* ......**.... */
	0x03, 0x00,	/* ......**.... */
	0x03, 0x00,	/* ......**.... */
	0x03, 0x00,	/* ......**.... */
	0x03, 0x00,	/* ......**.... */
	0x1f, 0x00,	/* ...*****.... */
	0x1f, 0x00,	/* ...*****.... */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */

	/* 94 0x5e '^' */
	0x00, 0x00,	/* ............ */
	0x04, 0x00,	/* .....*...... */
	0x0e, 0x00,	/* ....***..... */
	0x1b, 0x00,	/* ...**.**.... */
	0x31, 0x80,	/* ..**...**... */
	0x60, 0xc0,	/* .**.....**.. */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */

	/* 95 0x5f '_' */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0xff, 0xf0,	/* ************ */
	0xff, 0xf0,	/* ************ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */

	/* 96 0x60 '`' */
	0x00, 0x00,	/* ............ */
	0x01, 0x00,	/* .......*.... */
	0x03, 0x00,	/* ......**.... */
	0x06, 0x00,	/* .....**..... */
	0x06, 0x00,	/* .....**..... */
	0x07, 0x80,	/* .....****... */
	0x07, 0x80,	/* .....****... */
	0x03, 0x00,	/* ......**.... */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */

	/* 97 0x61 'a' */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x0f, 0x80,	/* ....*****... */
	0x18, 0xc0,	/* ...**...**.. */
	0x10, 0xc0,	/* ...*....**.. */
	0x03, 0xc0,	/* ......****.. */
	0x1c, 0xc0,	/* ...***..**.. */
	0x30, 0xc0,	/* ..**....**.. */
	0x30, 0xc0,	/* ..**....**.. */
	0x30, 0xc0,	/* ..**....**.. */
	0x39, 0xc0,	/* ..***..***.. */
	0x1e, 0xe0,	/* ...****.***. */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */

	/* 98 0x62 'b' */
	0x00, 0x00,	/* ............ */
	0x20, 0x00,	/* ..*......... */
	0x60, 0x00,	/* .**......... */
	0xe0, 0x00,	/* ***......... */
	0x60, 0x00,	/* .**......... */
	0x60, 0x00,	/* .**......... */
	0x67, 0x80,	/* .**..****... */
	0x6f, 0xc0,	/* .**.******.. */
	0x70, 0xe0,	/* .***....***. */
	0x60, 0x60,	/* .**......**. */
	0x60, 0x60,	/* .**......**. */
	0x60, 0x60,	/* .**......**. */
	0x60, 0x60,	/* .**......**. */
	0x70, 0x60,	/* .***.....**. */
	0x78, 0xc0,	/* .****...**.. */
	0x4f, 0x80,	/* .*..*****... */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */

	/* 99 0x63 'c' */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x1f, 0x80,	/* ...******... */
	0x31, 0xc0,	/* ..**...***.. */
	0x20, 0xc0,	/* ..*.....**.. */
	0x60, 0x00,	/* .**......... */
	0x60, 0x00,	/* .**......... */
	0x60, 0x00,	/* .**......... */
	0x60, 0x00,	/* .**......... */
	0x70, 0x40,	/* .***.....*.. */
	0x30, 0xc0,	/* ..**....**.. */
	0x1f, 0x80,	/* ...******... */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */

	/* 100 0x64 'd' */
	0x00, 0x00,	/* ............ */
	0x00, 0x60,	/* .........**. */
	0x00, 0xe0,	/* ........***. */
	0x00, 0x60,	/* .........**. */
	0x00, 0x60,	/* .........**. */
	0x00, 0x60,	/* .........**. */
	0x0f, 0x60,	/* ....****.**. */
	0x31, 0xe0,	/* ..**...****. */
	0x20, 0xe0,	/* ..*.....***. */
	0x60, 0x60,	/* .**......**. */
	0x60, 0x60,	/* .**......**. */
	0x60, 0x60,	/* .**......**. */
	0x60, 0x60,	/* .**......**. */
	0x70, 0xe0,	/* .***....***. */
	0x39, 0x60,	/* ..***..*.**. */
	0x1e, 0x70,	/* ...****..*** */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */

	/* 101 0x65 'e' */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x0f, 0x00,	/* ....****.... */
	0x30, 0xc0,	/* ..**....**.. */
	0x60, 0x60,	/* .**......**. */
	0x60, 0x60,	/* .**......**. */
	0x7f, 0xe0,	/* .**********. */
	0x60, 0x00,	/* .**......... */
	0x60, 0x00,	/* .**......... */
	0x30, 0x00,	/* ..**........ */
	0x18, 0x60,	/* ...**....**. */
	0x0f, 0x80,	/* ....*****... */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */

	/* 102 0x66 'f' */
	0x00, 0x00,	/* ............ */
	0x03, 0x80,	/* ......***... */
	0x04, 0xc0,	/* .....*..**.. */
	0x04, 0xc0,	/* .....*..**.. */
	0x0c, 0x00,	/* ....**...... */
	0x0c, 0x00,	/* ....**...... */
	0x0c, 0x00,	/* ....**...... */
	0x0c, 0x00,	/* ....**...... */
	0x3f, 0x80,	/* ..*******... */
	0x0c, 0x00,	/* ....**...... */
	0x0c, 0x00,	/* ....**...... */
	0x0c, 0x00,	/* ....**...... */
	0x0c, 0x00,	/* ....**...... */
	0x0c, 0x00,	/* ....**...... */
	0x0c, 0x00,	/* ....**...... */
	0x1e, 0x00,	/* ...****..... */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */

	/* 103 0x67 'g' */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x1f, 0x20,	/* ...*****..*. */
	0x31, 0xe0,	/* ..**...****. */
	0x60, 0xc0,	/* .**.....**.. */
	0x60, 0xc0,	/* .**.....**.. */
	0x60, 0xc0,	/* .**.....**.. */
	0x31, 0x80,	/* ..**...**... */
	0x3f, 0x00,	/* ..******.... */
	0x60, 0x00,	/* .**......... */
	0x7f, 0xc0,	/* .*********.. */
	0x3f, 0xe0,	/* ..*********. */
	0x20, 0x60,	/* ..*......**. */
	0x40, 0x20,	/* .*........*. */
	0x40, 0x20,	/* .*........*. */
	0x7f, 0xc0,	/* .*********.. */
	0x3f, 0x80,	/* ..*******... */
	0x00, 0x00,	/* ............ */

	/* 104 0x68 'h' */
	0x00, 0x00,	/* ............ */
	0x10, 0x00,	/* ...*........ */
	0x30, 0x00,	/* ..**........ */
	0x70, 0x00,	/* .***........ */
	0x30, 0x00,	/* ..**........ */
	0x30, 0x00,	/* ..**........ */
	0x37, 0x80,	/* ..**.****... */
	0x39, 0xc0,	/* ..***..***.. */
	0x30, 0xc0,	/* ..**....**.. */
	0x30, 0xc0,	/* ..**....**.. */
	0x30, 0xc0,	/* ..**....**.. */
	0x30, 0xc0,	/* ..**....**.. */
	0x30, 0xc0,	/* ..**....**.. */
	0x30, 0xc0,	/* ..**....**.. */
	0x30, 0xc0,	/* ..**....**.. */
	0x79, 0xe0,	/* .****..****. */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */

	/* 105 0x69 'i' */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x06, 0x00,	/* .....**..... */
	0x06, 0x00,	/* .....**..... */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x1e, 0x00,	/* ...****..... */
	0x06, 0x00,	/* .....**..... */
	0x06, 0x00,	/* .....**..... */
	0x06, 0x00,	/* .....**..... */
	0x06, 0x00,	/* .....**..... */
	0x06, 0x00,	/* .....**..... */
	0x06, 0x00,	/* .....**..... */
	0x06, 0x00,	/* .....**..... */
	0x06, 0x00,	/* .....**..... */
	0x1f, 0x80,	/* ...******... */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */

	/* 106 0x6a 'j' */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0xc0,	/* ........**.. */
	0x00, 0xc0,	/* ........**.. */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x03, 0xc0,	/* ......****.. */
	0x00, 0xc0,	/* ........**.. */
	0x00, 0xc0,	/* ........**.. */
	0x00, 0xc0,	/* ........**.. */
	0x00, 0xc0,	/* ........**.. */
	0x00, 0xc0,	/* ........**.. */
	0x00, 0xc0,	/* ........**.. */
	0x00, 0xc0,	/* ........**.. */
	0x00, 0xc0,	/* ........**.. */
	0x00, 0xc0,	/* ........**.. */
	0x20, 0xc0,	/* ..*.....**.. */
	0x30, 0xc0,	/* ..**....**.. */
	0x38, 0x80,	/* ..***...*... */
	0x1f, 0x00,	/* ...*****.... */
	0x0e, 0x00,	/* ....***..... */
	0x00, 0x00,	/* ............ */

	/* 107 0x6b 'k' */
	0x00, 0x00,	/* ............ */
	0x60, 0x00,	/* .**......... */
	0xe0, 0x00,	/* ***......... */
	0x60, 0x00,	/* .**......... */
	0x60, 0x00,	/* .**......... */
	0x60, 0x00,	/* .**......... */
	0x61, 0xc0,	/* .**....***.. */
	0x63, 0x00,	/* .**...**.... */
	0x66, 0x00,	/* .**..**..... */
	0x7c, 0x00,	/* .*****...... */
	0x78, 0x00,	/* .****....... */
	0x7c, 0x00,	/* .*****...... */
	0x6e, 0x00,	/* .**.***..... */
	0x67, 0x00,	/* .**..***.... */
	0x63, 0x80,	/* .**...***... */
	0xf1, 0xe0,	/* ****...****. */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */

	/* 108 0x6c 'l' */
	0x00, 0x00,	/* ............ */
	0x1e, 0x00,	/* ...****..... */
	0x06, 0x00,	/* .....**..... */
	0x06, 0x00,	/* .....**..... */
	0x06, 0x00,	/* .....**..... */
	0x06, 0x00,	/* .....**..... */
	0x06, 0x00,	/* .....**..... */
	0x06, 0x00,	/* .....**..... */
	0x06, 0x00,	/* .....**..... */
	0x06, 0x00,	/* .....**..... */
	0x06, 0x00,	/* .....**..... */
	0x06, 0x00,	/* .....**..... */
	0x06, 0x00,	/* .....**..... */
	0x06, 0x00,	/* .....**..... */
	0x06, 0x00,	/* .....**..... */
	0x1f, 0x80,	/* ...******... */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */

	/* 109 0x6d 'm' */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0xdd, 0xc0,	/* **.***.***.. */
	0x6e, 0xe0,	/* .**.***.***. */
	0x66, 0x60,	/* .**..**..**. */
	0x66, 0x60,	/* .**..**..**. */
	0x66, 0x60,	/* .**..**..**. */
	0x66, 0x60,	/* .**..**..**. */
	0x66, 0x60,	/* .**..**..**. */
	0x66, 0x60,	/* .**..**..**. */
	0x66, 0x60,	/* .**..**..**. */
	0xef, 0x70,	/* ***.****.*** */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */

	/* 110 0x6e 'n' */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x27, 0x80,	/* ..*..****... */
	0x79, 0xc0,	/* .****..***.. */
	0x30, 0xc0,	/* ..**....**.. */
	0x30, 0xc0,	/* ..**....**.. */
	0x30, 0xc0,	/* ..**....**.. */
	0x30, 0xc0,	/* ..**....**.. */
	0x30, 0xc0,	/* ..**....**.. */
	0x30, 0xc0,	/* ..**....**.. */
	0x30, 0xc0,	/* ..**....**.. */
	0x79, 0xe0,	/* .****..****. */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */

	/* 111 0x6f 'o' */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x0f, 0x80,	/* ....*****... */
	0x11, 0xc0,	/* ...*...***.. */
	0x20, 0xe0,	/* ..*.....***. */
	0x60, 0x60,	/* .**......**. */
	0x60, 0x60,	/* .**......**. */
	0x60, 0x60,	/* .**......**. */
	0x60, 0x60,	/* .**......**. */
	0x70, 0x40,	/* .***.....*.. */
	0x38, 0x80,	/* ..***...*... */
	0x1f, 0x00,	/* ...*****.... */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */

	/* 112 0x70 'p' */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0xef, 0x80,	/* ***.*****... */
	0x71, 0xc0,	/* .***...***.. */
	0x60, 0xe0,	/* .**.....***. */
	0x60, 0x60,	/* .**......**. */
	0x60, 0x60,	/* .**......**. */
	0x60, 0x60,	/* .**......**. */
	0x60, 0x60,	/* .**......**. */
	0x60, 0x40,	/* .**......*.. */
	0x70, 0x80,	/* .***....*... */
	0x7f, 0x00,	/* .*******.... */
	0x60, 0x00,	/* .**......... */
	0x60, 0x00,	/* .**......... */
	0x60, 0x00,	/* .**......... */
	0x60, 0x00,	/* .**......... */
	0xf0, 0x00,	/* ****........ */
	0x00, 0x00,	/* ............ */

	/* 113 0x71 'q' */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x0f, 0x20,	/* ....****..*. */
	0x11, 0xe0,	/* ...*...****. */
	0x20, 0xe0,	/* ..*.....***. */
	0x60, 0x60,	/* .**......**. */
	0x60, 0x60,	/* .**......**. */
	0x60, 0x60,	/* .**......**. */
	0x60, 0x60,	/* .**......**. */
	0x70, 0x60,	/* .***.....**. */
	0x38, 0xe0,	/* ..***...***. */
	0x1f, 0xe0,	/* ...********. */
	0x00, 0x60,	/* .........**. */
	0x00, 0x60,	/* .........**. */
	0x00, 0x60,	/* .........**. */
	0x00, 0x60,	/* .........**. */
	0x00, 0xf0,	/* ........**** */
	0x00, 0x00,	/* ............ */

	/* 114 0x72 'r' */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x73, 0x80,	/* .***..***... */
	0x34, 0xc0,	/* ..**.*..**.. */
	0x38, 0xc0,	/* ..***...**.. */
	0x30, 0x00,	/* ..**........ */
	0x30, 0x00,	/* ..**........ */
	0x30, 0x00,	/* ..**........ */
	0x30, 0x00,	/* ..**........ */
	0x30, 0x00,	/* ..**........ */
	0x30, 0x00,	/* ..**........ */
	0x78, 0x00,	/* .****....... */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */

	/* 115 0x73 's' */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x1f, 0xc0,	/* ...*******.. */
	0x30, 0xc0,	/* ..**....**.. */
	0x30, 0x40,	/* ..**.....*.. */
	0x38, 0x00,	/* ..***....... */
	0x1e, 0x00,	/* ...****..... */
	0x07, 0x80,	/* .....****... */
	0x01, 0xc0,	/* .......***.. */
	0x20, 0xc0,	/* ..*.....**.. */
	0x30, 0xc0,	/* ..**....**.. */
	0x3f, 0x80,	/* ..*******... */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */

	/* 116 0x74 't' */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x04, 0x00,	/* .....*...... */
	0x04, 0x00,	/* .....*...... */
	0x0c, 0x00,	/* ....**...... */
	0x7f, 0xc0,	/* .*********.. */
	0x0c, 0x00,	/* ....**...... */
	0x0c, 0x00,	/* ....**...... */
	0x0c, 0x00,	/* ....**...... */
	0x0c, 0x00,	/* ....**...... */
	0x0c, 0x00,	/* ....**...... */
	0x0c, 0x00,	/* ....**...... */
	0x0c, 0x20,	/* ....**....*. */
	0x0e, 0x40,	/* ....***..*.. */
	0x07, 0x80,	/* .....****... */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */

	/* 117 0x75 'u' */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x79, 0xe0,	/* .****..****. */
	0x30, 0xc0,	/* ..**....**.. */
	0x30, 0xc0,	/* ..**....**.. */
	0x30, 0xc0,	/* ..**....**.. */
	0x30, 0xc0,	/* ..**....**.. */
	0x30, 0xc0,	/* ..**....**.. */
	0x30, 0xc0,	/* ..**....**.. */
	0x30, 0xc0,	/* ..**....**.. */
	0x39, 0xc0,	/* ..***..***.. */
	0x1e, 0x60,	/* ...****..**. */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */

	/* 118 0x76 'v' */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0xf0, 0x70,	/* ****.....*** */
	0x60, 0x20,	/* .**.......*. */
	0x30, 0x40,	/* ..**.....*.. */
	0x30, 0x40,	/* ..**.....*.. */
	0x18, 0x80,	/* ...**...*... */
	0x18, 0x80,	/* ...**...*... */
	0x0d, 0x00,	/* ....**.*.... */
	0x0d, 0x00,	/* ....**.*.... */
	0x06, 0x00,	/* .....**..... */
	0x06, 0x00,	/* .....**..... */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */

	/* 119 0x77 'w' */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0xff, 0x70,	/* ********.*** */
	0x66, 0x20,	/* .**..**...*. */
	0x66, 0x20,	/* .**..**...*. */
	0x66, 0x20,	/* .**..**...*. */
	0x37, 0x40,	/* ..**.***.*.. */
	0x3b, 0x40,	/* ..***.**.*.. */
	0x3b, 0x40,	/* ..***.**.*.. */
	0x19, 0x80,	/* ...**..**... */
	0x19, 0x80,	/* ...**..**... */
	0x19, 0x80,	/* ...**..**... */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */

	/* 120 0x78 'x' */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0xf8, 0xf0,	/* *****...**** */
	0x70, 0x40,	/* .***.....*.. */
	0x38, 0x80,	/* ..***...*... */
	0x1d, 0x00,	/* ...***.*.... */
	0x0e, 0x00,	/* ....***..... */
	0x07, 0x00,	/* .....***.... */
	0x0b, 0x80,	/* ....*.***... */
	0x11, 0xc0,	/* ...*...***.. */
	0x20, 0xe0,	/* ..*.....***. */
	0xf1, 0xf0,	/* ****...***** */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */

	/* 121 0x79 'y' */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0xf0, 0xf0,	/* ****....**** */
	0x60, 0x20,	/* .**.......*. */
	0x30, 0x40,	/* ..**.....*.. */
	0x30, 0x40,	/* ..**.....*.. */
	0x18, 0x80,	/* ...**...*... */
	0x18, 0x80,	/* ...**...*... */
	0x0d, 0x00,	/* ....**.*.... */
	0x0d, 0x00,	/* ....**.*.... */
	0x06, 0x00,	/* .....**..... */
	0x06, 0x00,	/* .....**..... */
	0x04, 0x00,	/* .....*...... */
	0x0c, 0x00,	/* ....**...... */
	0x08, 0x00,	/* ....*....... */
	0x78, 0x00,	/* .****....... */
	0x70, 0x00,	/* .***........ */
	0x00, 0x00,	/* ............ */

	/* 122 0x7a 'z' */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x7f, 0xe0,	/* .**********. */
	0x60, 0xe0,	/* .**.....***. */
	0x41, 0xc0,	/* .*.....***.. */
	0x03, 0x80,	/* ......***... */
	0x07, 0x00,	/* .....***.... */
	0x0e, 0x00,	/* ....***..... */
	0x1c, 0x00,	/* ...***...... */
	0x38, 0x20,	/* ..***.....*. */
	0x70, 0x60,	/* .***.....**. */
	0x7f, 0xe0,	/* .**********. */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */

	/* 123 0x7b '{' */
	0x00, 0x00,	/* ............ */
	0x03, 0x80,	/* ......***... */
	0x06, 0x00,	/* .....**..... */
	0x06, 0x00,	/* .....**..... */
	0x06, 0x00,	/* .....**..... */
	0x06, 0x00,	/* .....**..... */
	0x06, 0x00,	/* .....**..... */
	0x0c, 0x00,	/* ....**...... */
	0x38, 0x00,	/* ..***....... */
	0x0c, 0x00,	/* ....**...... */
	0x06, 0x00,	/* .....**..... */
	0x06, 0x00,	/* .....**..... */
	0x06, 0x00,	/* .....**..... */
	0x06, 0x00,	/* .....**..... */
	0x06, 0x00,	/* .....**..... */
	0x03, 0x80,	/* ......***... */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */

	/* 124 0x7c '|' */
	0x00, 0x00,	/* ............ */
	0x06, 0x00,	/* .....**..... */
	0x06, 0x00,	/* .....**..... */
	0x06, 0x00,	/* .....**..... */
	0x06, 0x00,	/* .....**..... */
	0x06, 0x00,	/* .....**..... */
	0x06, 0x00,	/* .....**..... */
	0x06, 0x00,	/* .....**..... */
	0x06, 0x00,	/* .....**..... */
	0x06, 0x00,	/* .....**..... */
	0x06, 0x00,	/* .....**..... */
	0x06, 0x00,	/* .....**..... */
	0x06, 0x00,	/* .....**..... */
	0x06, 0x00,	/* .....**..... */
	0x06, 0x00,	/* .....**..... */
	0x06, 0x00,	/* .....**..... */
	0x06, 0x00,	/* .....**..... */
	0x06, 0x00,	/* .....**..... */
	0x06, 0x00,	/* .....**..... */
	0x06, 0x00,	/* .....**..... */
	0x06, 0x00,	/* .....**..... */
	0x00, 0x00,	/* ............ */

	/* 125 0x7d '}' */
	0x00, 0x00,	/* ............ */
	0x1c, 0x00,	/* ...***...... */
	0x06, 0x00,	/* .....**..... */
	0x06, 0x00,	/* .....**..... */
	0x06, 0x00,	/* .....**..... */
	0x06, 0x00,	/* .....**..... */
	0x06, 0x00,	/* .....**..... */
	0x03, 0x00,	/* ......**.... */
	0x01, 0xc0,	/* .......***.. */
	0x03, 0x00,	/* ......**.... */
	0x06, 0x00,	/* .....**..... */
	0x06, 0x00,	/* .....**..... */
	0x06, 0x00,	/* .....**..... */
	0x06, 0x00,	/* .....**..... */
	0x06, 0x00,	/* .....**..... */
	0x1c, 0x00,	/* ...***...... */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */

	/* 126 0x7e '~' */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x1c, 0x20,	/* ...***....*. */
	0x3e, 0x60,	/* ..*****..**. */
	0x67, 0xc0,	/* .**..*****.. */
	0x43, 0x80,	/* .*....***... */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */

	/* 127 0x7f '.' */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x3f, 0xc0,	/* ..********.. */
	0x3f, 0xc0,	/* ..********.. */
	0x3f, 0xc0,	/* ..********.. */
	0x3f, 0xc0,	/* ..********.. */
	0x3f, 0xc0,	/* ..********.. */
	0x3f, 0xc0,	/* ..********.. */
	0x3f, 0xc0,	/* ..********.. */
	0x3f, 0xc0,	/* ..********.. */
	0x3f, 0xc0,	/* ..********.. */
	0x3f, 0xc0,	/* ..********.. */
	0x3f, 0xc0,	/* ..********.. */
	0x3f, 0xc0,	/* ..********.. */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */

	/* 128 0x80 '.' */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x0f, 0xc0,	/* ....******.. */
	0x10, 0x60,	/* ...*.....**. */
	0x20, 0x20,	/* ..*.......*. */
	0x20, 0x00,	/* ..*......... */
	0x60, 0x00,	/* .**......... */
	0x60, 0x00,	/* .**......... */
	0x60, 0x00,	/* .**......... */
	0x60, 0x00,	/* .**......... */
	0x60, 0x00,	/* .**......... */
	0x60, 0x00,	/* .**......... */
	0x20, 0x00,	/* ..*......... */
	0x30, 0x20,	/* ..**......*. */
	0x18, 0x40,	/* ...**....*.. */
	0x0f, 0x80,	/* ....*****... */
	0x06, 0x00,	/* .....**..... */
	0x03, 0x00,	/* ......**.... */
	0x01, 0x80,	/* .......**... */
	0x0f, 0x00,	/* ....****.... */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */

	/* 129 0x81 '.' */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x19, 0x80,	/* ...**..**... */
	0x19, 0x80,	/* ...**..**... */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x79, 0xe0,	/* .****..****. */
	0x30, 0xc0,	/* ..**....**.. */
	0x30, 0xc0,	/* ..**....**.. */
	0x30, 0xc0,	/* ..**....**.. */
	0x30, 0xc0,	/* ..**....**.. */
	0x30, 0xc0,	/* ..**....**.. */
	0x30, 0xc0,	/* ..**....**.. */
	0x30, 0xc0,	/* ..**....**.. */
	0x39, 0xc0,	/* ..***..***.. */
	0x1e, 0x60,	/* ...****..**. */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */

	/* 130 0x82 '.' */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x01, 0x80,	/* .......**... */
	0x03, 0x00,	/* ......**.... */
	0x06, 0x00,	/* .....**..... */
	0x00, 0x00,	/* ............ */
	0x0f, 0x00,	/* ....****.... */
	0x30, 0xc0,	/* ..**....**.. */
	0x60, 0x60,	/* .**......**. */
	0x60, 0x60,	/* .**......**. */
	0x7f, 0xe0,	/* .**********. */
	0x60, 0x00,	/* .**......... */
	0x60, 0x00,	/* .**......... */
	0x30, 0x00,	/* ..**........ */
	0x18, 0x60,	/* ...**....**. */
	0x0f, 0x80,	/* ....*****... */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */

	/* 131 0x83 '.' */
	0x00, 0x00,	/* ............ */
	0x02, 0x00,	/* ......*..... */
	0x07, 0x00,	/* .....***.... */
	0x0d, 0x80,	/* ....**.**... */
	0x18, 0xc0,	/* ...**...**.. */
	0x00, 0x00,	/* ............ */
	0x0f, 0x80,	/* ....*****... */
	0x18, 0xc0,	/* ...**...**.. */
	0x10, 0xc0,	/* ...*....**.. */
	0x03, 0xc0,	/* ......****.. */
	0x1c, 0xc0,	/* ...***..**.. */
	0x30, 0xc0,	/* ..**....**.. */
	0x30, 0xc0,	/* ..**....**.. */
	0x30, 0xc0,	/* ..**....**.. */
	0x39, 0xc0,	/* ..***..***.. */
	0x1e, 0xe0,	/* ...****.***. */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */

	/* 132 0x84 '.' */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x19, 0x80,	/* ...**..**... */
	0x19, 0x80,	/* ...**..**... */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x0f, 0x80,	/* ....*****... */
	0x18, 0xc0,	/* ...**...**.. */
	0x10, 0xc0,	/* ...*....**.. */
	0x03, 0xc0,	/* ......****.. */
	0x1c, 0xc0,	/* ...***..**.. */
	0x30, 0xc0,	/* ..**....**.. */
	0x30, 0xc0,	/* ..**....**.. */
	0x30, 0xc0,	/* ..**....**.. */
	0x39, 0xc0,	/* ..***..***.. */
	0x1e, 0xe0,	/* ...****.***. */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */

	/* 133 0x85 '.' */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x0c, 0x00,	/* ....**...... */
	0x06, 0x00,	/* .....**..... */
	0x03, 0x00,	/* ......**.... */
	0x00, 0x00,	/* ............ */
	0x0f, 0x80,	/* ....*****... */
	0x18, 0xc0,	/* ...**...**.. */
	0x10, 0xc0,	/* ...*....**.. */
	0x03, 0xc0,	/* ......****.. */
	0x1c, 0xc0,	/* ...***..**.. */
	0x30, 0xc0,	/* ..**....**.. */
	0x30, 0xc0,	/* ..**....**.. */
	0x30, 0xc0,	/* ..**....**.. */
	0x39, 0xc0,	/* ..***..***.. */
	0x1e, 0xe0,	/* ...****.***. */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */

	/* 134 0x86 '.' */
	0x00, 0x00,	/* ............ */
	0x07, 0x00,	/* .....***.... */
	0x0d, 0x80,	/* ....**.**... */
	0x0d, 0x80,	/* ....**.**... */
	0x07, 0x00,	/* .....***.... */
	0x00, 0x00,	/* ............ */
	0x0f, 0x80,	/* ....*****... */
	0x18, 0xc0,	/* ...**...**.. */
	0x10, 0xc0,	/* ...*....**.. */
	0x03, 0xc0,	/* ......****.. */
	0x1c, 0xc0,	/* ...***..**.. */
	0x30, 0xc0,	/* ..**....**.. */
	0x30, 0xc0,	/* ..**....**.. */
	0x30, 0xc0,	/* ..**....**.. */
	0x39, 0xc0,	/* ..***..***.. */
	0x1e, 0xe0,	/* ...****.***. */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */

	/* 135 0x87 '.' */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x1f, 0x80,	/* ...******... */
	0x31, 0xc0,	/* ..**...***.. */
	0x20, 0xc0,	/* ..*.....**.. */
	0x60, 0x00,	/* .**......... */
	0x60, 0x00,	/* .**......... */
	0x60, 0x00,	/* .**......... */
	0x60, 0x00,	/* .**......... */
	0x70, 0x40,	/* .***.....*.. */
	0x30, 0xc0,	/* ..**....**.. */
	0x1f, 0x80,	/* ...******... */
	0x06, 0x00,	/* .....**..... */
	0x03, 0x00,	/* ......**.... */
	0x01, 0x80,	/* .......**... */
	0x0f, 0x00,	/* ....****.... */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */

	/* 136 0x88 '.' */
	0x00, 0x00,	/* ............ */
	0x02, 0x00,	/* ......*..... */
	0x07, 0x00,	/* .....***.... */
	0x0d, 0x80,	/* ....**.**... */
	0x18, 0xc0,	/* ...**...**.. */
	0x00, 0x00,	/* ............ */
	0x0f, 0x00,	/* ....****.... */
	0x30, 0xc0,	/* ..**....**.. */
	0x60, 0x60,	/* .**......**. */
	0x60, 0x60,	/* .**......**. */
	0x7f, 0xe0,	/* .**********. */
	0x60, 0x00,	/* .**......... */
	0x60, 0x00,	/* .**......... */
	0x30, 0x00,	/* ..**........ */
	0x18, 0x60,	/* ...**....**. */
	0x0f, 0x80,	/* ....*****... */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */

	/* 137 0x89 '.' */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x19, 0x80,	/* ...**..**... */
	0x19, 0x80,	/* ...**..**... */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x0f, 0x00,	/* ....****.... */
	0x30, 0xc0,	/* ..**....**.. */
	0x60, 0x60,	/* .**......**. */
	0x60, 0x60,	/* .**......**. */
	0x7f, 0xe0,	/* .**********. */
	0x60, 0x00,	/* .**......... */
	0x60, 0x00,	/* .**......... */
	0x30, 0x00,	/* ..**........ */
	0x18, 0x60,	/* ...**....**. */
	0x0f, 0x80,	/* ....*****... */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */

	/* 138 0x8a '.' */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x0c, 0x00,	/* ....**...... */
	0x06, 0x00,	/* .....**..... */
	0x03, 0x00,	/* ......**.... */
	0x00, 0x00,	/* ............ */
	0x0f, 0x00,	/* ....****.... */
	0x30, 0xc0,	/* ..**....**.. */
	0x60, 0x60,	/* .**......**. */
	0x60, 0x60,	/* .**......**. */
	0x7f, 0xe0,	/* .**********. */
	0x60, 0x00,	/* .**......... */
	0x60, 0x00,	/* .**......... */
	0x30, 0x00,	/* ..**........ */
	0x18, 0x60,	/* ...**....**. */
	0x0f, 0x80,	/* ....*****... */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */

	/* 139 0x8b '.' */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x19, 0x80,	/* ...**..**... */
	0x19, 0x80,	/* ...**..**... */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x1e, 0x00,	/* ...****..... */
	0x06, 0x00,	/* .....**..... */
	0x06, 0x00,	/* .....**..... */
	0x06, 0x00,	/* .....**..... */
	0x06, 0x00,	/* .....**..... */
	0x06, 0x00,	/* .....**..... */
	0x06, 0x00,	/* .....**..... */
	0x06, 0x00,	/* .....**..... */
	0x06, 0x00,	/* .....**..... */
	0x1f, 0x80,	/* ...******... */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */

	/* 140 0x8c '.' */
	0x00, 0x00,	/* ............ */
	0x04, 0x00,	/* .....*...... */
	0x0e, 0x00,	/* ....***..... */
	0x1b, 0x00,	/* ...**.**.... */
	0x31, 0x80,	/* ..**...**... */
	0x00, 0x00,	/* ............ */
	0x1e, 0x00,	/* ...****..... */
	0x06, 0x00,	/* .....**..... */
	0x06, 0x00,	/* .....**..... */
	0x06, 0x00,	/* .....**..... */
	0x06, 0x00,	/* .....**..... */
	0x06, 0x00,	/* .....**..... */
	0x06, 0x00,	/* .....**..... */
	0x06, 0x00,	/* .....**..... */
	0x06, 0x00,	/* .....**..... */
	0x1f, 0x80,	/* ...******... */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */

	/* 141 0x8d '.' */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x18, 0x00,	/* ...**....... */
	0x0c, 0x00,	/* ....**...... */
	0x06, 0x00,	/* .....**..... */
	0x00, 0x00,	/* ............ */
	0x1e, 0x00,	/* ...****..... */
	0x06, 0x00,	/* .....**..... */
	0x06, 0x00,	/* .....**..... */
	0x06, 0x00,	/* .....**..... */
	0x06, 0x00,	/* .....**..... */
	0x06, 0x00,	/* .....**..... */
	0x06, 0x00,	/* .....**..... */
	0x06, 0x00,	/* .....**..... */
	0x06, 0x00,	/* .....**..... */
	0x1f, 0x80,	/* ...******... */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */

	/* 142 0x8e '.' */
	0x00, 0x00,	/* ............ */
	0x19, 0x80,	/* ...**..**... */
	0x19, 0x80,	/* ...**..**... */
	0x00, 0x00,	/* ............ */
	0x04, 0x00,	/* .....*...... */
	0x06, 0x00,	/* .....**..... */
	0x06, 0x00,	/* .....**..... */
	0x0b, 0x00,	/* ....*.**.... */
	0x0b, 0x00,	/* ....*.**.... */
	0x19, 0x80,	/* ...**..**... */
	0x11, 0x80,	/* ...*...**... */
	0x3f, 0xc0,	/* ..********.. */
	0x20, 0xc0,	/* ..*.....**.. */
	0x60, 0x60,	/* .**......**. */
	0x40, 0x60,	/* .*.......**. */
	0xe0, 0xf0,	/* ***.....**** */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */

	/* 143 0x8f '.' */
	0x00, 0x00,	/* ............ */
	0x0f, 0x00,	/* ....****.... */
	0x19, 0x80,	/* ...**..**... */
	0x0f, 0x00,	/* ....****.... */
	0x04, 0x00,	/* .....*...... */
	0x06, 0x00,	/* .....**..... */
	0x06, 0x00,	/* .....**..... */
	0x0b, 0x00,	/* ....*.**.... */
	0x0b, 0x00,	/* ....*.**.... */
	0x19, 0x80,	/* ...**..**... */
	0x11, 0x80,	/* ...*...**... */
	0x3f, 0xc0,	/* ..********.. */
	0x20, 0xc0,	/* ..*.....**.. */
	0x60, 0x60,	/* .**......**. */
	0x40, 0x60,	/* .*.......**. */
	0xe0, 0xf0,	/* ***.....**** */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */

	/* 144 0x90 '.' */
	0x00, 0x00,	/* ............ */
	0x03, 0x00,	/* ......**.... */
	0x06, 0x00,	/* .....**..... */
	0x08, 0x00,	/* ....*....... */
	0x7f, 0xe0,	/* .**********. */
	0x30, 0x20,	/* ..**......*. */
	0x30, 0x00,	/* ..**........ */
	0x30, 0x00,	/* ..**........ */
	0x30, 0x80,	/* ..**....*... */
	0x3f, 0x80,	/* ..*******... */
	0x30, 0x80,	/* ..**....*... */
	0x30, 0x00,	/* ..**........ */
	0x30, 0x00,	/* ..**........ */
	0x30, 0x20,	/* ..**......*. */
	0x30, 0x20,	/* ..**......*. */
	0x7f, 0xe0,	/* .**********. */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */

	/* 145 0x91 '.' */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x3d, 0xe0,	/* ..****.****. */
	0x66, 0x30,	/* .**..**...** */
	0x46, 0x30,	/* .*...**...** */
	0x06, 0x30,	/* .....**...** */
	0x3f, 0xf0,	/* ..********** */
	0x66, 0x00,	/* .**..**..... */
	0xc6, 0x00,	/* **...**..... */
	0xc6, 0x00,	/* **...**..... */
	0xe7, 0x30,	/* ***..***..** */
	0x7d, 0xe0,	/* .*****.****. */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */

	/* 146 0x92 '.' */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x03, 0xf0,	/* ......****** */
	0x07, 0x10,	/* .....***...* */
	0x07, 0x10,	/* .....***...* */
	0x0b, 0x00,	/* ....*.**.... */
	0x0b, 0x00,	/* ....*.**.... */
	0x0b, 0x20,	/* ....*.**..*. */
	0x13, 0xe0,	/* ...*..*****. */
	0x13, 0x20,	/* ...*..**..*. */
	0x3f, 0x00,	/* ..******.... */
	0x23, 0x00,	/* ..*...**.... */
	0x23, 0x00,	/* ..*...**.... */
	0x43, 0x10,	/* .*....**...* */
	0x43, 0x10,	/* .*....**...* */
	0xe7, 0xf0,	/* ***..******* */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */

	/* 147 0x93 '.' */
	0x00, 0x00,	/* ............ */
	0x02, 0x00,	/* ......*..... */
	0x07, 0x00,	/* .....***.... */
	0x0d, 0x80,	/* ....**.**... */
	0x18, 0xc0,	/* ...**...**.. */
	0x00, 0x00,	/* ............ */
	0x0f, 0x80,	/* ....*****... */
	0x11, 0xc0,	/* ...*...***.. */
	0x20, 0xe0,	/* ..*.....***. */
	0x60, 0x60,	/* .**......**. */
	0x60, 0x60,	/* .**......**. */
	0x60, 0x60,	/* .**......**. */
	0x60, 0x60,	/* .**......**. */
	0x70, 0x40,	/* .***.....*.. */
	0x38, 0x80,	/* ..***...*... */
	0x1f, 0x00,	/* ...*****.... */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */

	/* 148 0x94 '.' */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x19, 0x80,	/* ...**..**... */
	0x19, 0x80,	/* ...**..**... */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x0f, 0x80,	/* ....*****... */
	0x11, 0xc0,	/* ...*...***.. */
	0x20, 0xe0,	/* ..*.....***. */
	0x60, 0x60,	/* .**......**. */
	0x60, 0x60,	/* .**......**. */
	0x60, 0x60,	/* .**......**. */
	0x60, 0x60,	/* .**......**. */
	0x70, 0x40,	/* .***.....*.. */
	0x38, 0x80,	/* ..***...*... */
	0x1f, 0x00,	/* ...*****.... */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */

	/* 149 0x95 '.' */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x0c, 0x00,	/* ....**...... */
	0x06, 0x00,	/* .....**..... */
	0x03, 0x00,	/* ......**.... */
	0x00, 0x00,	/* ............ */
	0x0f, 0x80,	/* ....*****... */
	0x11, 0xc0,	/* ...*...***.. */
	0x20, 0xe0,	/* ..*.....***. */
	0x60, 0x60,	/* .**......**. */
	0x60, 0x60,	/* .**......**. */
	0x60, 0x60,	/* .**......**. */
	0x60, 0x60,	/* .**......**. */
	0x70, 0x40,	/* .***.....*.. */
	0x38, 0x80,	/* ..***...*... */
	0x1f, 0x00,	/* ...*****.... */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */

	/* 150 0x96 '.' */
	0x00, 0x00,	/* ............ */
	0x02, 0x00,	/* ......*..... */
	0x07, 0x00,	/* .....***.... */
	0x0d, 0x80,	/* ....**.**... */
	0x18, 0xc0,	/* ...**...**.. */
	0x00, 0x00,	/* ............ */
	0x79, 0xe0,	/* .****..****. */
	0x30, 0xc0,	/* ..**....**.. */
	0x30, 0xc0,	/* ..**....**.. */
	0x30, 0xc0,	/* ..**....**.. */
	0x30, 0xc0,	/* ..**....**.. */
	0x30, 0xc0,	/* ..**....**.. */
	0x30, 0xc0,	/* ..**....**.. */
	0x30, 0xc0,	/* ..**....**.. */
	0x39, 0xc0,	/* ..***..***.. */
	0x1e, 0x60,	/* ...****..**. */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */

	/* 151 0x97 '.' */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x18, 0x00,	/* ...**....... */
	0x0c, 0x00,	/* ....**...... */
	0x06, 0x00,	/* .....**..... */
	0x00, 0x00,	/* ............ */
	0x79, 0xe0,	/* .****..****. */
	0x30, 0xc0,	/* ..**....**.. */
	0x30, 0xc0,	/* ..**....**.. */
	0x30, 0xc0,	/* ..**....**.. */
	0x30, 0xc0,	/* ..**....**.. */
	0x30, 0xc0,	/* ..**....**.. */
	0x30, 0xc0,	/* ..**....**.. */
	0x30, 0xc0,	/* ..**....**.. */
	0x39, 0xc0,	/* ..***..***.. */
	0x1e, 0x60,	/* ...****..**. */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */

	/* 152 0x98 '.' */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x19, 0x80,	/* ...**..**... */
	0x19, 0x80,	/* ...**..**... */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0xf0, 0xf0,	/* ****....**** */
	0x60, 0x20,	/* .**.......*. */
	0x30, 0x40,	/* ..**.....*.. */
	0x30, 0x40,	/* ..**.....*.. */
	0x18, 0x80,	/* ...**...*... */
	0x18, 0x80,	/* ...**...*... */
	0x0d, 0x00,	/* ....**.*.... */
	0x0d, 0x00,	/* ....**.*.... */
	0x06, 0x00,	/* .....**..... */
	0x06, 0x00,	/* .....**..... */
	0x04, 0x00,	/* .....*...... */
	0x0c, 0x00,	/* ....**...... */
	0x08, 0x00,	/* ....*....... */
	0x78, 0x00,	/* .****....... */
	0x70, 0x00,	/* .***........ */
	0x00, 0x00,	/* ............ */

	/* 153 0x99 '.' */
	0x00, 0x00,	/* ............ */
	0x19, 0x80,	/* ...**..**... */
	0x19, 0x80,	/* ...**..**... */
	0x00, 0x00,	/* ............ */
	0x0f, 0x80,	/* ....*****... */
	0x11, 0xc0,	/* ...*...***.. */
	0x20, 0xc0,	/* ..*.....**.. */
	0x20, 0x60,	/* ..*......**. */
	0x60, 0x60,	/* .**......**. */
	0x60, 0x60,	/* .**......**. */
	0x60, 0x60,	/* .**......**. */
	0x60, 0x60,	/* .**......**. */
	0x20, 0x40,	/* ..*......*.. */
	0x30, 0x40,	/* ..**.....*.. */
	0x18, 0x80,	/* ...**...*... */
	0x0f, 0x00,	/* ....****.... */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */

	/* 154 0x9a '.' */
	0x00, 0x00,	/* ............ */
	0x19, 0x80,	/* ...**..**... */
	0x19, 0x80,	/* ...**..**... */
	0xe0, 0x30,	/* ***.......** */
	0x60, 0x20,	/* .**.......*. */
	0x60, 0x20,	/* .**.......*. */
	0x60, 0x20,	/* .**.......*. */
	0x60, 0x20,	/* .**.......*. */
	0x60, 0x20,	/* .**.......*. */
	0x60, 0x20,	/* .**.......*. */
	0x60, 0x20,	/* .**.......*. */
	0x60, 0x20,	/* .**.......*. */
	0x60, 0x20,	/* .**.......*. */
	0x70, 0x40,	/* .***.....*.. */
	0x3f, 0xc0,	/* ..********.. */
	0x1f, 0x80,	/* ...******... */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */

	/* 155 0x9b '.' */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x06, 0x00,	/* .....**..... */
	0x06, 0x00,	/* .....**..... */
	0x1f, 0x80,	/* ...******... */
	0x36, 0xc0,	/* ..**.**.**.. */
	0x26, 0xc0,	/* ..*..**.**.. */
	0x66, 0x00,	/* .**..**..... */
	0x66, 0x00,	/* .**..**..... */
	0x66, 0x00,	/* .**..**..... */
	0x66, 0x00,	/* .**..**..... */
	0x76, 0x40,	/* .***.**..*.. */
	0x36, 0xc0,	/* ..**.**.**.. */
	0x1f, 0x80,	/* ...******... */
	0x06, 0x00,	/* .....**..... */
	0x06, 0x00,	/* .....**..... */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */

	/* 156 0x9c '.' */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x0f, 0x80,	/* ....*****... */
	0x1c, 0xc0,	/* ...***..**.. */
	0x18, 0xc0,	/* ...**...**.. */
	0x18, 0x00,	/* ...**....... */
	0x18, 0x00,	/* ...**....... */
	0x18, 0x00,	/* ...**....... */
	0x7e, 0x00,	/* .******..... */
	0x7e, 0x00,	/* .******..... */
	0x18, 0x00,	/* ...**....... */
	0x18, 0x00,	/* ...**....... */
	0x18, 0x00,	/* ...**....... */
	0x18, 0x00,	/* ...**....... */
	0x3e, 0x20,	/* ..*****...*. */
	0x7f, 0xe0,	/* .**********. */
	0x61, 0xc0,	/* .**....***.. */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */

	/* 157 0x9d '.' */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x60, 0x60,	/* .**......**. */
	0x60, 0x60,	/* .**......**. */
	0x30, 0xc0,	/* ..**....**.. */
	0x19, 0x80,	/* ...**..**... */
	0x19, 0x80,	/* ...**..**... */
	0x0f, 0x00,	/* ....****.... */
	0x06, 0x00,	/* .....**..... */
	0x1f, 0x80,	/* ...******... */
	0x06, 0x00,	/* .....**..... */
	0x1f, 0x80,	/* ...******... */
	0x06, 0x00,	/* .....**..... */
	0x06, 0x00,	/* .....**..... */
	0x06, 0x00,	/* .....**..... */
	0x06, 0x00,	/* .....**..... */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */

	/* 158 0x9e '.' */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x3f, 0xc0,	/* ..********.. */
	0x3f, 0xc0,	/* ..********.. */
	0x3f, 0xc0,	/* ..********.. */
	0x3f, 0xc0,	/* ..********.. */
	0x3f, 0xc0,	/* ..********.. */
	0x3f, 0xc0,	/* ..********.. */
	0x3f, 0xc0,	/* ..********.. */
	0x3f, 0xc0,	/* ..********.. */
	0x3f, 0xc0,	/* ..********.. */
	0x3f, 0xc0,	/* ..********.. */
	0x3f, 0xc0,	/* ..********.. */
	0x3f, 0xc0,	/* ..********.. */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */

	/* 159 0x9f '.' */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x3f, 0xc0,	/* ..********.. */
	0x3f, 0xc0,	/* ..********.. */
	0x3f, 0xc0,	/* ..********.. */
	0x3f, 0xc0,	/* ..********.. */
	0x3f, 0xc0,	/* ..********.. */
	0x3f, 0xc0,	/* ..********.. */
	0x3f, 0xc0,	/* ..********.. */
	0x3f, 0xc0,	/* ..********.. */
	0x3f, 0xc0,	/* ..********.. */
	0x3f, 0xc0,	/* ..********.. */
	0x3f, 0xc0,	/* ..********.. */
	0x3f, 0xc0,	/* ..********.. */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */

	/* 160 0xa0 '.' */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x01, 0x80,	/* .......**... */
	0x03, 0x00,	/* ......**.... */
	0x06, 0x00,	/* .....**..... */
	0x00, 0x00,	/* ............ */
	0x0f, 0x80,	/* ....*****... */
	0x18, 0xc0,	/* ...**...**.. */
	0x10, 0xc0,	/* ...*....**.. */
	0x03, 0xc0,	/* ......****.. */
	0x1c, 0xc0,	/* ...***..**.. */
	0x30, 0xc0,	/* ..**....**.. */
	0x30, 0xc0,	/* ..**....**.. */
	0x30, 0xc0,	/* ..**....**.. */
	0x39, 0xc0,	/* ..***..***.. */
	0x1e, 0xe0,	/* ...****.***. */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */

	/* 161 0xa1 '.' */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x01, 0x80,	/* .......**... */
	0x03, 0x00,	/* ......**.... */
	0x06, 0x00,	/* .....**..... */
	0x00, 0x00,	/* ............ */
	0x1e, 0x00,	/* ...****..... */
	0x06, 0x00,	/* .....**..... */
	0x06, 0x00,	/* .....**..... */
	0x06, 0x00,	/* .....**..... */
	0x06, 0x00,	/* .....**..... */
	0x06, 0x00,	/* .....**..... */
	0x06, 0x00,	/* .....**..... */
	0x06, 0x00,	/* .....**..... */
	0x06, 0x00,	/* .....**..... */
	0x1f, 0x80,	/* ...******... */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */

	/* 162 0xa2 '.' */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x01, 0x80,	/* .......**... */
	0x03, 0x00,	/* ......**.... */
	0x06, 0x00,	/* .....**..... */
	0x00, 0x00,	/* ............ */
	0x0f, 0x80,	/* ....*****... */
	0x11, 0xc0,	/* ...*...***.. */
	0x20, 0xe0,	/* ..*.....***. */
	0x60, 0x60,	/* .**......**. */
	0x60, 0x60,	/* .**......**. */
	0x60, 0x60,	/* .**......**. */
	0x60, 0x60,	/* .**......**. */
	0x70, 0x40,	/* .***.....*.. */
	0x38, 0x80,	/* ..***...*... */
	0x1f, 0x00,	/* ...*****.... */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */

	/* 163 0xa3 '.' */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x01, 0x80,	/* .......**... */
	0x03, 0x00,	/* ......**.... */
	0x06, 0x00,	/* .....**..... */
	0x00, 0x00,	/* ............ */
	0x79, 0xe0,	/* .****..****. */
	0x30, 0xc0,	/* ..**....**.. */
	0x30, 0xc0,	/* ..**....**.. */
	0x30, 0xc0,	/* ..**....**.. */
	0x30, 0xc0,	/* ..**....**.. */
	0x30, 0xc0,	/* ..**....**.. */
	0x30, 0xc0,	/* ..**....**.. */
	0x30, 0xc0,	/* ..**....**.. */
	0x39, 0xc0,	/* ..***..***.. */
	0x1e, 0x60,	/* ...****..**. */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */

	/* 164 0xa4 '.' */
	0x00, 0x00,	/* ............ */
	0x1c, 0x40,	/* ...***...*.. */
	0x3f, 0xc0,	/* ..********.. */
	0x23, 0x80,	/* ..*...***... */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x27, 0x80,	/* ..*..****... */
	0x79, 0xc0,	/* .****..***.. */
	0x30, 0xc0,	/* ..**....**.. */
	0x30, 0xc0,	/* ..**....**.. */
	0x30, 0xc0,	/* ..**....**.. */
	0x30, 0xc0,	/* ..**....**.. */
	0x30, 0xc0,	/* ..**....**.. */
	0x30, 0xc0,	/* ..**....**.. */
	0x30, 0xc0,	/* ..**....**.. */
	0x79, 0xe0,	/* .****..****. */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */

	/* 165 0xa5 '.' */
	0x00, 0x00,	/* ............ */
	0x1c, 0x40,	/* ...***...*.. */
	0x3f, 0xc0,	/* ..********.. */
	0x23, 0x80,	/* ..*...***... */
	0xc0, 0x70,	/* **.......*** */
	0x60, 0x20,	/* .**.......*. */
	0x70, 0x20,	/* .***......*. */
	0x78, 0x20,	/* .****.....*. */
	0x5c, 0x20,	/* .*.***....*. */
	0x4e, 0x20,	/* .*..***...*. */
	0x47, 0x20,	/* .*...***..*. */
	0x43, 0xa0,	/* .*....***.*. */
	0x41, 0xe0,	/* .*.....****. */
	0x40, 0xe0,	/* .*......***. */
	0x40, 0x60,	/* .*.......**. */
	0xe0, 0x30,	/* ***.......** */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */

	/* 166 0xa6 '.' */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x1f, 0x00,	/* ...*****.... */
	0x31, 0x80,	/* ..**...**... */
	0x01, 0x80,	/* .......**... */
	0x07, 0x80,	/* .....****... */
	0x19, 0x80,	/* ...**..**... */
	0x31, 0x80,	/* ..**...**... */
	0x31, 0x80,	/* ..**...**... */
	0x33, 0x80,	/* ..**..***... */
	0x1d, 0xc0,	/* ...***.***.. */
	0x00, 0x00,	/* ............ */
	0x3f, 0xc0,	/* ..********.. */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */

	/* 167 0xa7 '.' */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x07, 0x00,	/* .....***.... */
	0x19, 0x80,	/* ...**..**... */
	0x10, 0xc0,	/* ...*....**.. */
	0x30, 0xc0,	/* ..**....**.. */
	0x30, 0xc0,	/* ..**....**.. */
	0x30, 0xc0,	/* ..**....**.. */
	0x30, 0x80,	/* ..**....*... */
	0x19, 0x80,	/* ...**..**... */
	0x0e, 0x00,	/* ....***..... */
	0x00, 0x00,	/* ............ */
	0x3f, 0xc0,	/* ..********.. */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */

	/* 168 0xa8 '.' */
	0x00, 0x00,	/* ............ */
	0x03, 0x00,	/* ......**.... */
	0x03, 0x00,	/* ......**.... */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x03, 0x00,	/* ......**.... */
	0x03, 0x00,	/* ......**.... */
	0x06, 0x00,	/* .....**..... */
	0x0c, 0x00,	/* ....**...... */
	0x18, 0x00,	/* ...**....... */
	0x30, 0x00,	/* ..**........ */
	0x30, 0x00,	/* ..**........ */
	0x30, 0x40,	/* ..**.....*.. */
	0x39, 0xc0,	/* ..***..***.. */
	0x1f, 0x80,	/* ...******... */
	0x0f, 0x00,	/* ....****.... */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */

	/* 169 0xa9 '.' */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x3f, 0xc0,	/* ..********.. */
	0x3f, 0xc0,	/* ..********.. */
	0x3f, 0xc0,	/* ..********.. */
	0x3f, 0xc0,	/* ..********.. */
	0x3f, 0xc0,	/* ..********.. */
	0x3f, 0xc0,	/* ..********.. */
	0x3f, 0xc0,	/* ..********.. */
	0x3f, 0xc0,	/* ..********.. */
	0x3f, 0xc0,	/* ..********.. */
	0x3f, 0xc0,	/* ..********.. */
	0x3f, 0xc0,	/* ..********.. */
	0x3f, 0xc0,	/* ..********.. */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */

	/* 170 0xaa '.' */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x3f, 0xc0,	/* ..********.. */
	0x3f, 0xc0,	/* ..********.. */
	0x00, 0xc0,	/* ........**.. */
	0x00, 0xc0,	/* ........**.. */
	0x00, 0xc0,	/* ........**.. */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */

	/* 171 0xab '.' */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x10, 0x00,	/* ...*........ */
	0x30, 0x00,	/* ..**........ */
	0x10, 0x00,	/* ...*........ */
	0x10, 0x40,	/* ...*.....*.. */
	0x10, 0x80,	/* ...*....*... */
	0x11, 0x00,	/* ...*...*.... */
	0x3a, 0x00,	/* ..***.*..... */
	0x05, 0xc0,	/* .....*.***.. */
	0x0a, 0x20,	/* ....*.*...*. */
	0x10, 0x20,	/* ...*......*. */
	0x20, 0xc0,	/* ..*.....**.. */
	0x41, 0x00,	/* .*.....*.... */
	0x02, 0x00,	/* ......*..... */
	0x03, 0xe0,	/* ......*****. */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */

	/* 172 0xac '.' */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x10, 0x00,	/* ...*........ */
	0x30, 0x00,	/* ..**........ */
	0x10, 0x00,	/* ...*........ */
	0x10, 0x40,	/* ...*.....*.. */
	0x10, 0x80,	/* ...*....*... */
	0x11, 0x00,	/* ...*...*.... */
	0x3a, 0x40,	/* ..***.*..*.. */
	0x04, 0xc0,	/* .....*..**.. */
	0x09, 0x40,	/* ....*..*.*.. */
	0x12, 0x40,	/* ...*..*..*.. */
	0x24, 0x40,	/* ..*..*...*.. */
	0x47, 0xe0,	/* .*...******. */
	0x00, 0x40,	/* .........*.. */
	0x00, 0x40,	/* .........*.. */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */

	/* 173 0xad '.' */
	0x00, 0x00,	/* ............ */
	0x06, 0x00,	/* .....**..... */
	0x06, 0x00,	/* .....**..... */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x06, 0x00,	/* .....**..... */
	0x06, 0x00,	/* .....**..... */
	0x06, 0x00,	/* .....**..... */
	0x06, 0x00,	/* .....**..... */
	0x06, 0x00,	/* .....**..... */
	0x06, 0x00,	/* .....**..... */
	0x06, 0x00,	/* .....**..... */
	0x06, 0x00,	/* .....**..... */
	0x06, 0x00,	/* .....**..... */
	0x06, 0x00,	/* .....**..... */
	0x06, 0x00,	/* .....**..... */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */

	/* 174 0xae '.' */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x06, 0x60,	/* .....**..**. */
	0x0c, 0xc0,	/* ....**..**.. */
	0x19, 0x80,	/* ...**..**... */
	0x33, 0x00,	/* ..**..**.... */
	0x66, 0x00,	/* .**..**..... */
	0x33, 0x00,	/* ..**..**.... */
	0x19, 0x80,	/* ...**..**... */
	0x0c, 0xc0,	/* ....**..**.. */
	0x06, 0x60,	/* .....**..**. */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */

	/* 175 0xaf '.' */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x66, 0x00,	/* .**..**..... */
	0x33, 0x00,	/* ..**..**.... */
	0x19, 0x80,	/* ...**..**... */
	0x0c, 0xc0,	/* ....**..**.. */
	0x06, 0x60,	/* .....**..**. */
	0x0c, 0xc0,	/* ....**..**.. */
	0x19, 0x80,	/* ...**..**... */
	0x33, 0x00,	/* ..**..**.... */
	0x66, 0x00,	/* .**..**..... */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */

	/* 176 0xb0 '.' */
	0x0c, 0x30,	/* ....**....** */
	0x08, 0x20,	/* ....*.....*. */
	0x61, 0x80,	/* .**....**... */
	0x20, 0x80,	/* ..*.....*... */
	0x0c, 0x30,	/* ....**....** */
	0x08, 0x20,	/* ....*.....*. */
	0x61, 0x80,	/* .**....**... */
	0x20, 0x80,	/* ..*.....*... */
	0x0c, 0x30,	/* ....**....** */
	0x08, 0x20,	/* ....*.....*. */
	0x61, 0x80,	/* .**....**... */
	0x20, 0x80,	/* ..*.....*... */
	0x0c, 0x30,	/* ....**....** */
	0x08, 0x20,	/* ....*.....*. */
	0x61, 0x80,	/* .**....**... */
	0x20, 0x80,	/* ..*.....*... */
	0x0c, 0x30,	/* ....**....** */
	0x08, 0x20,	/* ....*.....*. */
	0x61, 0x80,	/* .**....**... */
	0x20, 0x80,	/* ..*.....*... */
	0x0c, 0x30,	/* ....**....** */
	0x08, 0x20,	/* ....*.....*. */

	/* 177 0xb1 '.' */
	0x77, 0x70,	/* .***.***.*** */
	0x22, 0x20,	/* ..*...*...*. */
	0x88, 0x80,	/* *...*...*... */
	0xdd, 0xd0,	/* **.***.***.* */
	0x88, 0x80,	/* *...*...*... */
	0x22, 0x20,	/* ..*...*...*. */
	0x77, 0x70,	/* .***.***.*** */
	0x22, 0x20,	/* ..*...*...*. */
	0x88, 0x80,	/* *...*...*... */
	0xdd, 0xd0,	/* **.***.***.* */
	0x88, 0x80,	/* *...*...*... */
	0x22, 0x20,	/* ..*...*...*. */
	0x77, 0x70,	/* .***.***.*** */
	0x22, 0x20,	/* ..*...*...*. */
	0x88, 0x80,	/* *...*...*... */
	0xdd, 0xd0,	/* **.***.***.* */
	0x88, 0x80,	/* *...*...*... */
	0x22, 0x20,	/* ..*...*...*. */
	0x77, 0x70,	/* .***.***.*** */
	0x22, 0x20,	/* ..*...*...*. */
	0x88, 0x80,	/* *...*...*... */
	0xdd, 0xd0,	/* **.***.***.* */

	/* 178 0xb2 '.' */
	0xf3, 0xc0,	/* ****..****.. */
	0xf7, 0xd0,	/* ****.*****.* */
	0x9e, 0x70,	/* *..****..*** */
	0xdf, 0x70,	/* **.*****.*** */
	0xf3, 0xc0,	/* ****..****.. */
	0xf7, 0xd0,	/* ****.*****.* */
	0x9e, 0x70,	/* *..****..*** */
	0xdf, 0x70,	/* **.*****.*** */
	0xf3, 0xc0,	/* ****..****.. */
	0xf7, 0xd0,	/* ****.*****.* */
	0x9e, 0x70,	/* *..****..*** */
	0xdf, 0x70,	/* **.*****.*** */
	0xf3, 0xc0,	/* ****..****.. */
	0xf7, 0xd0,	/* ****.*****.* */
	0x9e, 0x70,	/* *..****..*** */
	0xdf, 0x70,	/* **.*****.*** */
	0xf3, 0xc0,	/* ****..****.. */
	0xf7, 0xd0,	/* ****.*****.* */
	0x9e, 0x70,	/* *..****..*** */
	0xdf, 0x70,	/* **.*****.*** */
	0xf3, 0xc0,	/* ****..****.. */
	0xf7, 0xd0,	/* ****.*****.* */

	/* 179 0xb3 '.' */
	0x06, 0x00,	/* .....**..... */
	0x06, 0x00,	/* .....**..... */
	0x06, 0x00,	/* .....**..... */
	0x06, 0x00,	/* .....**..... */
	0x06, 0x00,	/* .....**..... */
	0x06, 0x00,	/* .....**..... */
	0x06, 0x00,	/* .....**..... */
	0x06, 0x00,	/* .....**..... */
	0x06, 0x00,	/* .....**..... */
	0x06, 0x00,	/* .....**..... */
	0x06, 0x00,	/* .....**..... */
	0x06, 0x00,	/* .....**..... */
	0x06, 0x00,	/* .....**..... */
	0x06, 0x00,	/* .....**..... */
	0x06, 0x00,	/* .....**..... */
	0x06, 0x00,	/* .....**..... */
	0x06, 0x00,	/* .....**..... */
	0x06, 0x00,	/* .....**..... */
	0x06, 0x00,	/* .....**..... */
	0x06, 0x00,	/* .....**..... */
	0x06, 0x00,	/* .....**..... */
	0x06, 0x00,	/* .....**..... */

	/* 180 0xb4 '.' */
	0x06, 0x00,	/* .....**..... */
	0x06, 0x00,	/* .....**..... */
	0x06, 0x00,	/* .....**..... */
	0x06, 0x00,	/* .....**..... */
	0x06, 0x00,	/* .....**..... */
	0x06, 0x00,	/* .....**..... */
	0x06, 0x00,	/* .....**..... */
	0x06, 0x00,	/* .....**..... */
	0x06, 0x00,	/* .....**..... */
	0x06, 0x00,	/* .....**..... */
	0xfe, 0x00,	/* *******..... */
	0xfe, 0x00,	/* *******..... */
	0x06, 0x00,	/* .....**..... */
	0x06, 0x00,	/* .....**..... */
	0x06, 0x00,	/* .....**..... */
	0x06, 0x00,	/* .....**..... */
	0x06, 0x00,	/* .....**..... */
	0x06, 0x00,	/* .....**..... */
	0x06, 0x00,	/* .....**..... */
	0x06, 0x00,	/* .....**..... */
	0x06, 0x00,	/* .....**..... */
	0x06, 0x00,	/* .....**..... */

	/* 181 0xb5 '.' */
	0x06, 0x00,	/* .....**..... */
	0x06, 0x00,	/* .....**..... */
	0x06, 0x00,	/* .....**..... */
	0x06, 0x00,	/* .....**..... */
	0x06, 0x00,	/* .....**..... */
	0x06, 0x00,	/* .....**..... */
	0x06, 0x00,	/* .....**..... */
	0xfe, 0x00,	/* *******..... */
	0xfe, 0x00,	/* *******..... */
	0x06, 0x00,	/* .....**..... */
	0xfe, 0x00,	/* *******..... */
	0xfe, 0x00,	/* *******..... */
	0x06, 0x00,	/* .....**..... */
	0x06, 0x00,	/* .....**..... */
	0x06, 0x00,	/* .....**..... */
	0x06, 0x00,	/* .....**..... */
	0x06, 0x00,	/* .....**..... */
	0x06, 0x00,	/* .....**..... */
	0x06, 0x00,	/* .....**..... */
	0x06, 0x00,	/* .....**..... */
	0x06, 0x00,	/* .....**..... */
	0x06, 0x00,	/* .....**..... */

	/* 182 0xb6 '.' */
	0x0d, 0x80,	/* ....**.**... */
	0x0d, 0x80,	/* ....**.**... */
	0x0d, 0x80,	/* ....**.**... */
	0x0d, 0x80,	/* ....**.**... */
	0x0d, 0x80,	/* ....**.**... */
	0x0d, 0x80,	/* ....**.**... */
	0x0d, 0x80,	/* ....**.**... */
	0x0d, 0x80,	/* ....**.**... */
	0x0d, 0x80,	/* ....**.**... */
	0x0d, 0x80,	/* ....**.**... */
	0xfd, 0x80,	/* ******.**... */
	0xfd, 0x80,	/* ******.**... */
	0x0d, 0x80,	/* ....**.**... */
	0x0d, 0x80,	/* ....**.**... */
	0x0d, 0x80,	/* ....**.**... */
	0x0d, 0x80,	/* ....**.**... */
	0x0d, 0x80,	/* ....**.**... */
	0x0d, 0x80,	/* ....**.**... */
	0x0d, 0x80,	/* ....**.**... */
	0x0d, 0x80,	/* ....**.**... */
	0x0d, 0x80,	/* ....**.**... */
	0x0d, 0x80,	/* ....**.**... */

	/* 183 0xb7 '.' */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0xff, 0x80,	/* *********... */
	0xff, 0x80,	/* *********... */
	0x0d, 0x80,	/* ....**.**... */
	0x0d, 0x80,	/* ....**.**... */
	0x0d, 0x80,	/* ....**.**... */
	0x0d, 0x80,	/* ....**.**... */
	0x0d, 0x80,	/* ....**.**... */
	0x0d, 0x80,	/* ....**.**... */
	0x0d, 0x80,	/* ....**.**... */
	0x0d, 0x80,	/* ....**.**... */
	0x0d, 0x80,	/* ....**.**... */
	0x0d, 0x80,	/* ....**.**... */

	/* 184 0xb8 '.' */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0xfe, 0x00,	/* *******..... */
	0xfe, 0x00,	/* *******..... */
	0x06, 0x00,	/* .....**..... */
	0xfe, 0x00,	/* *******..... */
	0xfe, 0x00,	/* *******..... */
	0x06, 0x00,	/* .....**..... */
	0x06, 0x00,	/* .....**..... */
	0x06, 0x00,	/* .....**..... */
	0x06, 0x00,	/* .....**..... */
	0x06, 0x00,	/* .....**..... */
	0x06, 0x00,	/* .....**..... */
	0x06, 0x00,	/* .....**..... */
	0x06, 0x00,	/* .....**..... */
	0x06, 0x00,	/* .....**..... */
	0x06, 0x00,	/* .....**..... */

	/* 185 0xb9 '.' */
	0x0d, 0x80,	/* ....**.**... */
	0x0d, 0x80,	/* ....**.**... */
	0x0d, 0x80,	/* ....**.**... */
	0x0d, 0x80,	/* ....**.**... */
	0x0d, 0x80,	/* ....**.**... */
	0x0d, 0x80,	/* ....**.**... */
	0x0d, 0x80,	/* ....**.**... */
	0xfd, 0x80,	/* ******.**... */
	0xfd, 0x80,	/* ******.**... */
	0x01, 0x80,	/* .......**... */
	0xfd, 0x80,	/* ******.**... */
	0xfd, 0x80,	/* ******.**... */
	0x0d, 0x80,	/* ....**.**... */
	0x0d, 0x80,	/* ....**.**... */
	0x0d, 0x80,	/* ....**.**... */
	0x0d, 0x80,	/* ....**.**... */
	0x0d, 0x80,	/* ....**.**... */
	0x0d, 0x80,	/* ....**.**... */
	0x0d, 0x80,	/* ....**.**... */
	0x0d, 0x80,	/* ....**.**... */
	0x0d, 0x80,	/* ....**.**... */
	0x0d, 0x80,	/* ....**.**... */

	/* 186 0xba '.' */
	0x0d, 0x80,	/* ....**.**... */
	0x0d, 0x80,	/* ....**.**... */
	0x0d, 0x80,	/* ....**.**... */
	0x0d, 0x80,	/* ....**.**... */
	0x0d, 0x80,	/* ....**.**... */
	0x0d, 0x80,	/* ....**.**... */
	0x0d, 0x80,	/* ....**.**... */
	0x0d, 0x80,	/* ....**.**... */
	0x0d, 0x80,	/* ....**.**... */
	0x0d, 0x80,	/* ....**.**... */
	0x0d, 0x80,	/* ....**.**... */
	0x0d, 0x80,	/* ....**.**... */
	0x0d, 0x80,	/* ....**.**... */
	0x0d, 0x80,	/* ....**.**... */
	0x0d, 0x80,	/* ....**.**... */
	0x0d, 0x80,	/* ....**.**... */
	0x0d, 0x80,	/* ....**.**... */
	0x0d, 0x80,	/* ....**.**... */
	0x0d, 0x80,	/* ....**.**... */
	0x0d, 0x80,	/* ....**.**... */
	0x0d, 0x80,	/* ....**.**... */
	0x0d, 0x80,	/* ....**.**... */

	/* 187 0xbb '.' */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0xff, 0x80,	/* *********... */
	0xff, 0x80,	/* *********... */
	0x01, 0x80,	/* .......**... */
	0xfd, 0x80,	/* ******.**... */
	0xfd, 0x80,	/* ******.**... */
	0x0d, 0x80,	/* ....**.**... */
	0x0d, 0x80,	/* ....**.**... */
	0x0d, 0x80,	/* ....**.**... */
	0x0d, 0x80,	/* ....**.**... */
	0x0d, 0x80,	/* ....**.**... */
	0x0d, 0x80,	/* ....**.**... */
	0x0d, 0x80,	/* ....**.**... */
	0x0d, 0x80,	/* ....**.**... */
	0x0d, 0x80,	/* ....**.**... */
	0x0d, 0x80,	/* ....**.**... */

	/* 188 0xbc '.' */
	0x0d, 0x80,	/* ....**.**... */
	0x0d, 0x80,	/* ....**.**... */
	0x0d, 0x80,	/* ....**.**... */
	0x0d, 0x80,	/* ....**.**... */
	0x0d, 0x80,	/* ....**.**... */
	0x0d, 0x80,	/* ....**.**... */
	0x0d, 0x80,	/* ....**.**... */
	0xfd, 0x80,	/* ******.**... */
	0xfd, 0x80,	/* ******.**... */
	0x01, 0x80,	/* .......**... */
	0xff, 0x80,	/* *********... */
	0xff, 0x80,	/* *********... */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */

	/* 189 0xbd '.' */
	0x0d, 0x80,	/* ....**.**... */
	0x0d, 0x80,	/* ....**.**... */
	0x0d, 0x80,	/* ....**.**... */
	0x0d, 0x80,	/* ....**.**... */
	0x0d, 0x80,	/* ....**.**... */
	0x0d, 0x80,	/* ....**.**... */
	0x0d, 0x80,	/* ....**.**... */
	0x0d, 0x80,	/* ....**.**... */
	0x0d, 0x80,	/* ....**.**... */
	0x0d, 0x80,	/* ....**.**... */
	0xff, 0x80,	/* *********... */
	0xff, 0x80,	/* *********... */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */

	/* 190 0xbe '.' */
	0x06, 0x00,	/* .....**..... */
	0x06, 0x00,	/* .....**..... */
	0x06, 0x00,	/* .....**..... */
	0x06, 0x00,	/* .....**..... */
	0x06, 0x00,	/* .....**..... */
	0x06, 0x00,	/* .....**..... */
	0x06, 0x00,	/* .....**..... */
	0xfe, 0x00,	/* *******..... */
	0xfe, 0x00,	/* *******..... */
	0x06, 0x00,	/* .....**..... */
	0xfe, 0x00,	/* *******..... */
	0xfe, 0x00,	/* *******..... */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */

	/* 191 0xbf '.' */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0xfe, 0x00,	/* *******..... */
	0xfe, 0x00,	/* *******..... */
	0x06, 0x00,	/* .....**..... */
	0x06, 0x00,	/* .....**..... */
	0x06, 0x00,	/* .....**..... */
	0x06, 0x00,	/* .....**..... */
	0x06, 0x00,	/* .....**..... */
	0x06, 0x00,	/* .....**..... */
	0x06, 0x00,	/* .....**..... */
	0x06, 0x00,	/* .....**..... */
	0x06, 0x00,	/* .....**..... */
	0x06, 0x00,	/* .....**..... */

	/* 192 0xc0 '.' */
	0x06, 0x00,	/* .....**..... */
	0x06, 0x00,	/* .....**..... */
	0x06, 0x00,	/* .....**..... */
	0x06, 0x00,	/* .....**..... */
	0x06, 0x00,	/* .....**..... */
	0x06, 0x00,	/* .....**..... */
	0x06, 0x00,	/* .....**..... */
	0x06, 0x00,	/* .....**..... */
	0x06, 0x00,	/* .....**..... */
	0x06, 0x00,	/* .....**..... */
	0x07, 0xf0,	/* .....******* */
	0x07, 0xf0,	/* .....******* */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */

	/* 193 0xc1 '.' */
	0x06, 0x00,	/* .....**..... */
	0x06, 0x00,	/* .....**..... */
	0x06, 0x00,	/* .....**..... */
	0x06, 0x00,	/* .....**..... */
	0x06, 0x00,	/* .....**..... */
	0x06, 0x00,	/* .....**..... */
	0x06, 0x00,	/* .....**..... */
	0x06, 0x00,	/* .....**..... */
	0x06, 0x00,	/* .....**..... */
	0x06, 0x00,	/* .....**..... */
	0xff, 0xf0,	/* ************ */
	0xff, 0xf0,	/* ************ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */

	/* 194 0xc2 '.' */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0xff, 0xf0,	/* ************ */
	0xff, 0xf0,	/* ************ */
	0x06, 0x00,	/* .....**..... */
	0x06, 0x00,	/* .....**..... */
	0x06, 0x00,	/* .....**..... */
	0x06, 0x00,	/* .....**..... */
	0x06, 0x00,	/* .....**..... */
	0x06, 0x00,	/* .....**..... */
	0x06, 0x00,	/* .....**..... */
	0x06, 0x00,	/* .....**..... */
	0x06, 0x00,	/* .....**..... */
	0x06, 0x00,	/* .....**..... */

	/* 195 0xc3 '.' */
	0x06, 0x00,	/* .....**..... */
	0x06, 0x00,	/* .....**..... */
	0x06, 0x00,	/* .....**..... */
	0x06, 0x00,	/* .....**..... */
	0x06, 0x00,	/* .....**..... */
	0x06, 0x00,	/* .....**..... */
	0x06, 0x00,	/* .....**..... */
	0x06, 0x00,	/* .....**..... */
	0x06, 0x00,	/* .....**..... */
	0x06, 0x00,	/* .....**..... */
	0x07, 0xf0,	/* .....******* */
	0x07, 0xf0,	/* .....******* */
	0x06, 0x00,	/* .....**..... */
	0x06, 0x00,	/* .....**..... */
	0x06, 0x00,	/* .....**..... */
	0x06, 0x00,	/* .....**..... */
	0x06, 0x00,	/* .....**..... */
	0x06, 0x00,	/* .....**..... */
	0x06, 0x00,	/* .....**..... */
	0x06, 0x00,	/* .....**..... */
	0x06, 0x00,	/* .....**..... */
	0x06, 0x00,	/* .....**..... */

	/* 196 0xc4 '.' */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0xff, 0xf0,	/* ************ */
	0xff, 0xf0,	/* ************ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */

	/* 197 0xc5 '.' */
	0x06, 0x00,	/* .....**..... */
	0x06, 0x00,	/* .....**..... */
	0x06, 0x00,	/* .....**..... */
	0x06, 0x00,	/* .....**..... */
	0x06, 0x00,	/* .....**..... */
	0x06, 0x00,	/* .....**..... */
	0x06, 0x00,	/* .....**..... */
	0x06, 0x00,	/* .....**..... */
	0x06, 0x00,	/* .....**..... */
	0x06, 0x00,	/* .....**..... */
	0xff, 0xf0,	/* ************ */
	0xff, 0xf0,	/* ************ */
	0x06, 0x00,	/* .....**..... */
	0x06, 0x00,	/* .....**..... */
	0x06, 0x00,	/* .....**..... */
	0x06, 0x00,	/* .....**..... */
	0x06, 0x00,	/* .....**..... */
	0x06, 0x00,	/* .....**..... */
	0x06, 0x00,	/* .....**..... */
	0x06, 0x00,	/* .....**..... */
	0x06, 0x00,	/* .....**..... */
	0x06, 0x00,	/* .....**..... */

	/* 198 0xc6 '.' */
	0x06, 0x00,	/* .....**..... */
	0x06, 0x00,	/* .....**..... */
	0x06, 0x00,	/* .....**..... */
	0x06, 0x00,	/* .....**..... */
	0x06, 0x00,	/* .....**..... */
	0x06, 0x00,	/* .....**..... */
	0x06, 0x00,	/* .....**..... */
	0x07, 0xf0,	/* .....******* */
	0x07, 0xf0,	/* .....******* */
	0x06, 0x00,	/* .....**..... */
	0x07, 0xf0,	/* .....******* */
	0x07, 0xf0,	/* .....******* */
	0x06, 0x00,	/* .....**..... */
	0x06, 0x00,	/* .....**..... */
	0x06, 0x00,	/* .....**..... */
	0x06, 0x00,	/* .....**..... */
	0x06, 0x00,	/* .....**..... */
	0x06, 0x00,	/* .....**..... */
	0x06, 0x00,	/* .....**..... */
	0x06, 0x00,	/* .....**..... */
	0x06, 0x00,	/* .....**..... */
	0x06, 0x00,	/* .....**..... */

	/* 199 0xc7 '.' */
	0x0d, 0x80,	/* ....**.**... */
	0x0d, 0x80,	/* ....**.**... */
	0x0d, 0x80,	/* ....**.**... */
	0x0d, 0x80,	/* ....**.**... */
	0x0d, 0x80,	/* ....**.**... */
	0x0d, 0x80,	/* ....**.**... */
	0x0d, 0x80,	/* ....**.**... */
	0x0d, 0x80,	/* ....**.**... */
	0x0d, 0x80,	/* ....**.**... */
	0x0d, 0x80,	/* ....**.**... */
	0x0d, 0xf0,	/* ....**.***** */
	0x0d, 0xf0,	/* ....**.***** */
	0x0d, 0x80,	/* ....**.**... */
	0x0d, 0x80,	/* ....**.**... */
	0x0d, 0x80,	/* ....**.**... */
	0x0d, 0x80,	/* ....**.**... */
	0x0d, 0x80,	/* ....**.**... */
	0x0d, 0x80,	/* ....**.**... */
	0x0d, 0x80,	/* ....**.**... */
	0x0d, 0x80,	/* ....**.**... */
	0x0d, 0x80,	/* ....**.**... */
	0x0d, 0x80,	/* ....**.**... */

	/* 200 0xc8 '.' */
	0x0d, 0x80,	/* ....**.**... */
	0x0d, 0x80,	/* ....**.**... */
	0x0d, 0x80,	/* ....**.**... */
	0x0d, 0x80,	/* ....**.**... */
	0x0d, 0x80,	/* ....**.**... */
	0x0d, 0x80,	/* ....**.**... */
	0x0d, 0x80,	/* ....**.**... */
	0x0d, 0xf0,	/* ....**.***** */
	0x0d, 0xf0,	/* ....**.***** */
	0x0c, 0x00,	/* ....**...... */
	0x0f, 0xf0,	/* ....******** */
	0x0f, 0xf0,	/* ....******** */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */

	/* 201 0xc9 '.' */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x0f, 0xf0,	/* ....******** */
	0x0f, 0xf0,	/* ....******** */
	0x0c, 0x00,	/* ....**...... */
	0x0d, 0xf0,	/* ....**.***** */
	0x0d, 0xf0,	/* ....**.***** */
	0x0d, 0x80,	/* ....**.**... */
	0x0d, 0x80,	/* ....**.**... */
	0x0d, 0x80,	/* ....**.**... */
	0x0d, 0x80,	/* ....**.**... */
	0x0d, 0x80,	/* ....**.**... */
	0x0d, 0x80,	/* ....**.**... */
	0x0d, 0x80,	/* ....**.**... */
	0x0d, 0x80,	/* ....**.**... */
	0x0d, 0x80,	/* ....**.**... */
	0x0d, 0x80,	/* ....**.**... */

	/* 202 0xca '.' */
	0x0d, 0x80,	/* ....**.**... */
	0x0d, 0x80,	/* ....**.**... */
	0x0d, 0x80,	/* ....**.**... */
	0x0d, 0x80,	/* ....**.**... */
	0x0d, 0x80,	/* ....**.**... */
	0x0d, 0x80,	/* ....**.**... */
	0x0d, 0x80,	/* ....**.**... */
	0xfd, 0xf0,	/* ******.***** */
	0xfd, 0xf0,	/* ******.***** */
	0x00, 0x00,	/* ............ */
	0xff, 0xf0,	/* ************ */
	0xff, 0xf0,	/* ************ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */

	/* 203 0xcb '.' */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0xff, 0xf0,	/* ************ */
	0xff, 0xf0,	/* ************ */
	0x00, 0x00,	/* ............ */
	0xfd, 0xf0,	/* ******.***** */
	0xfd, 0xf0,	/* ******.***** */
	0x0d, 0x80,	/* ....**.**... */
	0x0d, 0x80,	/* ....**.**... */
	0x0d, 0x80,	/* ....**.**... */
	0x0d, 0x80,	/* ....**.**... */
	0x0d, 0x80,	/* ....**.**... */
	0x0d, 0x80,	/* ....**.**... */
	0x0d, 0x80,	/* ....**.**... */
	0x0d, 0x80,	/* ....**.**... */
	0x0d, 0x80,	/* ....**.**... */
	0x0d, 0x80,	/* ....**.**... */

	/* 204 0xcc '.' */
	0x0d, 0x80,	/* ....**.**... */
	0x0d, 0x80,	/* ....**.**... */
	0x0d, 0x80,	/* ....**.**... */
	0x0d, 0x80,	/* ....**.**... */
	0x0d, 0x80,	/* ....**.**... */
	0x0d, 0x80,	/* ....**.**... */
	0x0d, 0x80,	/* ....**.**... */
	0x0d, 0xf0,	/* ....**.***** */
	0x0d, 0xf0,	/* ....**.***** */
	0x0c, 0x00,	/* ....**...... */
	0x0d, 0xf0,	/* ....**.***** */
	0x0d, 0xf0,	/* ....**.***** */
	0x0d, 0x80,	/* ....**.**... */
	0x0d, 0x80,	/* ....**.**... */
	0x0d, 0x80,	/* ....**.**... */
	0x0d, 0x80,	/* ....**.**... */
	0x0d, 0x80,	/* ....**.**... */
	0x0d, 0x80,	/* ....**.**... */
	0x0d, 0x80,	/* ....**.**... */
	0x0d, 0x80,	/* ....**.**... */
	0x0d, 0x80,	/* ....**.**... */
	0x0d, 0x80,	/* ....**.**... */

	/* 205 0xcd '.' */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0xff, 0xf0,	/* ************ */
	0xff, 0xf0,	/* ************ */
	0x00, 0x00,	/* ............ */
	0xff, 0xf0,	/* ************ */
	0xff, 0xf0,	/* ************ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */

	/* 206 0xce '.' */
	0x0d, 0x80,	/* ....**.**... */
	0x0d, 0x80,	/* ....**.**... */
	0x0d, 0x80,	/* ....**.**... */
	0x0d, 0x80,	/* ....**.**... */
	0x0d, 0x80,	/* ....**.**... */
	0x0d, 0x80,	/* ....**.**... */
	0x0d, 0x80,	/* ....**.**... */
	0xfd, 0xf0,	/* ******.***** */
	0xfd, 0xf0,	/* ******.***** */
	0x00, 0x00,	/* ............ */
	0xfd, 0xf0,	/* ******.***** */
	0xfd, 0xf0,	/* ******.***** */
	0x0d, 0x80,	/* ....**.**... */
	0x0d, 0x80,	/* ....**.**... */
	0x0d, 0x80,	/* ....**.**... */
	0x0d, 0x80,	/* ....**.**... */
	0x0d, 0x80,	/* ....**.**... */
	0x0d, 0x80,	/* ....**.**... */
	0x0d, 0x80,	/* ....**.**... */
	0x0d, 0x80,	/* ....**.**... */
	0x0d, 0x80,	/* ....**.**... */
	0x0d, 0x80,	/* ....**.**... */

	/* 207 0xcf '.' */
	0x06, 0x00,	/* .....**..... */
	0x06, 0x00,	/* .....**..... */
	0x06, 0x00,	/* .....**..... */
	0x06, 0x00,	/* .....**..... */
	0x06, 0x00,	/* .....**..... */
	0x06, 0x00,	/* .....**..... */
	0x06, 0x00,	/* .....**..... */
	0xff, 0xf0,	/* ************ */
	0xff, 0xf0,	/* ************ */
	0x00, 0x00,	/* ............ */
	0xff, 0xf0,	/* ************ */
	0xff, 0xf0,	/* ************ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */

	/* 208 0xd0 '.' */
	0x0d, 0x80,	/* ....**.**... */
	0x0d, 0x80,	/* ....**.**... */
	0x0d, 0x80,	/* ....**.**... */
	0x0d, 0x80,	/* ....**.**... */
	0x0d, 0x80,	/* ....**.**... */
	0x0d, 0x80,	/* ....**.**... */
	0x0d, 0x80,	/* ....**.**... */
	0x0d, 0x80,	/* ....**.**... */
	0x0d, 0x80,	/* ....**.**... */
	0x0d, 0x80,	/* ....**.**... */
	0xff, 0xf0,	/* ************ */
	0xff, 0xf0,	/* ************ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */

	/* 209 0xd1 '.' */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0xff, 0xf0,	/* ************ */
	0xff, 0xf0,	/* ************ */
	0x00, 0x00,	/* ............ */
	0xff, 0xf0,	/* ************ */
	0xff, 0xf0,	/* ************ */
	0x06, 0x00,	/* .....**..... */
	0x06, 0x00,	/* .....**..... */
	0x06, 0x00,	/* .....**..... */
	0x06, 0x00,	/* .....**..... */
	0x06, 0x00,	/* .....**..... */
	0x06, 0x00,	/* .....**..... */
	0x06, 0x00,	/* .....**..... */
	0x06, 0x00,	/* .....**..... */
	0x06, 0x00,	/* .....**..... */
	0x06, 0x00,	/* .....**..... */

	/* 210 0xd2 '.' */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0xff, 0xf0,	/* ************ */
	0xff, 0xf0,	/* ************ */
	0x0d, 0x80,	/* ....**.**... */
	0x0d, 0x80,	/* ....**.**... */
	0x0d, 0x80,	/* ....**.**... */
	0x0d, 0x80,	/* ....**.**... */
	0x0d, 0x80,	/* ....**.**... */
	0x0d, 0x80,	/* ....**.**... */
	0x0d, 0x80,	/* ....**.**... */
	0x0d, 0x80,	/* ....**.**... */
	0x0d, 0x80,	/* ....**.**... */
	0x0d, 0x80,	/* ....**.**... */

	/* 211 0xd3 '.' */
	0x0d, 0x80,	/* ....**.**... */
	0x0d, 0x80,	/* ....**.**... */
	0x0d, 0x80,	/* ....**.**... */
	0x0d, 0x80,	/* ....**.**... */
	0x0d, 0x80,	/* ....**.**... */
	0x0d, 0x80,	/* ....**.**... */
	0x0d, 0x80,	/* ....**.**... */
	0x0d, 0x80,	/* ....**.**... */
	0x0d, 0x80,	/* ....**.**... */
	0x0d, 0x80,	/* ....**.**... */
	0x0f, 0xf0,	/* ....******** */
	0x0f, 0xf0,	/* ....******** */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */

	/* 212 0xd4 '.' */
	0x06, 0x00,	/* .....**..... */
	0x06, 0x00,	/* .....**..... */
	0x06, 0x00,	/* .....**..... */
	0x06, 0x00,	/* .....**..... */
	0x06, 0x00,	/* .....**..... */
	0x06, 0x00,	/* .....**..... */
	0x06, 0x00,	/* .....**..... */
	0x07, 0xf0,	/* .....******* */
	0x07, 0xf0,	/* .....******* */
	0x06, 0x00,	/* .....**..... */
	0x07, 0xf0,	/* .....******* */
	0x07, 0xf0,	/* .....******* */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */

	/* 213 0xd5 '.' */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x07, 0xf0,	/* .....******* */
	0x07, 0xf0,	/* .....******* */
	0x06, 0x00,	/* .....**..... */
	0x07, 0xf0,	/* .....******* */
	0x07, 0xf0,	/* .....******* */
	0x06, 0x00,	/* .....**..... */
	0x06, 0x00,	/* .....**..... */
	0x06, 0x00,	/* .....**..... */
	0x06, 0x00,	/* .....**..... */
	0x06, 0x00,	/* .....**..... */
	0x06, 0x00,	/* .....**..... */
	0x06, 0x00,	/* .....**..... */
	0x06, 0x00,	/* .....**..... */
	0x06, 0x00,	/* .....**..... */
	0x06, 0x00,	/* .....**..... */

	/* 214 0xd6 '.' */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x0f, 0xf0,	/* ....******** */
	0x0f, 0xf0,	/* ....******** */
	0x0d, 0x80,	/* ....**.**... */
	0x0d, 0x80,	/* ....**.**... */
	0x0d, 0x80,	/* ....**.**... */
	0x0d, 0x80,	/* ....**.**... */
	0x0d, 0x80,	/* ....**.**... */
	0x0d, 0x80,	/* ....**.**... */
	0x0d, 0x80,	/* ....**.**... */
	0x0d, 0x80,	/* ....**.**... */
	0x0d, 0x80,	/* ....**.**... */
	0x0d, 0x80,	/* ....**.**... */

	/* 215 0xd7 '.' */
	0x0d, 0x80,	/* ....**.**... */
	0x0d, 0x80,	/* ....**.**... */
	0x0d, 0x80,	/* ....**.**... */
	0x0d, 0x80,	/* ....**.**... */
	0x0d, 0x80,	/* ....**.**... */
	0x0d, 0x80,	/* ....**.**... */
	0x0d, 0x80,	/* ....**.**... */
	0x0d, 0x80,	/* ....**.**... */
	0x0d, 0x80,	/* ....**.**... */
	0x0d, 0x80,	/* ....**.**... */
	0xff, 0xf0,	/* ************ */
	0xff, 0xf0,	/* ************ */
	0x0d, 0x80,	/* ....**.**... */
	0x0d, 0x80,	/* ....**.**... */
	0x0d, 0x80,	/* ....**.**... */
	0x0d, 0x80,	/* ....**.**... */
	0x0d, 0x80,	/* ....**.**... */
	0x0d, 0x80,	/* ....**.**... */
	0x0d, 0x80,	/* ....**.**... */
	0x0d, 0x80,	/* ....**.**... */
	0x0d, 0x80,	/* ....**.**... */
	0x0d, 0x80,	/* ....**.**... */

	/* 216 0xd8 '.' */
	0x06, 0x00,	/* .....**..... */
	0x06, 0x00,	/* .....**..... */
	0x06, 0x00,	/* .....**..... */
	0x06, 0x00,	/* .....**..... */
	0x06, 0x00,	/* .....**..... */
	0x06, 0x00,	/* .....**..... */
	0x06, 0x00,	/* .....**..... */
	0xff, 0xf0,	/* ************ */
	0xff, 0xf0,	/* ************ */
	0x06, 0x00,	/* .....**..... */
	0xff, 0xf0,	/* ************ */
	0xff, 0xf0,	/* ************ */
	0x06, 0x00,	/* .....**..... */
	0x06, 0x00,	/* .....**..... */
	0x06, 0x00,	/* .....**..... */
	0x06, 0x00,	/* .....**..... */
	0x06, 0x00,	/* .....**..... */
	0x06, 0x00,	/* .....**..... */
	0x06, 0x00,	/* .....**..... */
	0x06, 0x00,	/* .....**..... */
	0x06, 0x00,	/* .....**..... */
	0x06, 0x00,	/* .....**..... */

	/* 217 0xd9 '.' */
	0x06, 0x00,	/* .....**..... */
	0x06, 0x00,	/* .....**..... */
	0x06, 0x00,	/* .....**..... */
	0x06, 0x00,	/* .....**..... */
	0x06, 0x00,	/* .....**..... */
	0x06, 0x00,	/* .....**..... */
	0x06, 0x00,	/* .....**..... */
	0x06, 0x00,	/* .....**..... */
	0x06, 0x00,	/* .....**..... */
	0x06, 0x00,	/* .....**..... */
	0xfe, 0x00,	/* *******..... */
	0xfe, 0x00,	/* *******..... */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */

	/* 218 0xda '.' */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x07, 0xf0,	/* .....******* */
	0x07, 0xf0,	/* .....******* */
	0x06, 0x00,	/* .....**..... */
	0x06, 0x00,	/* .....**..... */
	0x06, 0x00,	/* .....**..... */
	0x06, 0x00,	/* .....**..... */
	0x06, 0x00,	/* .....**..... */
	0x06, 0x00,	/* .....**..... */
	0x06, 0x00,	/* .....**..... */
	0x06, 0x00,	/* .....**..... */
	0x06, 0x00,	/* .....**..... */
	0x06, 0x00,	/* .....**..... */

	/* 219 0xdb '.' */
	0xff, 0xf0,	/* ************ */
	0xff, 0xf0,	/* ************ */
	0xff, 0xf0,	/* ************ */
	0xff, 0xf0,	/* ************ */
	0xff, 0xf0,	/* ************ */
	0xff, 0xf0,	/* ************ */
	0xff, 0xf0,	/* ************ */
	0xff, 0xf0,	/* ************ */
	0xff, 0xf0,	/* ************ */
	0xff, 0xf0,	/* ************ */
	0xff, 0xf0,	/* ************ */
	0xff, 0xf0,	/* ************ */
	0xff, 0xf0,	/* ************ */
	0xff, 0xf0,	/* ************ */
	0xff, 0xf0,	/* ************ */
	0xff, 0xf0,	/* ************ */
	0xff, 0xf0,	/* ************ */
	0xff, 0xf0,	/* ************ */
	0xff, 0xf0,	/* ************ */
	0xff, 0xf0,	/* ************ */
	0xff, 0xf0,	/* ************ */
	0xff, 0xf0,	/* ************ */

	/* 220 0xdc '.' */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0xff, 0xf0,	/* ************ */
	0xff, 0xf0,	/* ************ */
	0xff, 0xf0,	/* ************ */
	0xff, 0xf0,	/* ************ */
	0xff, 0xf0,	/* ************ */
	0xff, 0xf0,	/* ************ */
	0xff, 0xf0,	/* ************ */
	0xff, 0xf0,	/* ************ */
	0xff, 0xf0,	/* ************ */
	0xff, 0xf0,	/* ************ */
	0xff, 0xf0,	/* ************ */
	0xff, 0xf0,	/* ************ */

	/* 221 0xdd '.' */
	0xfc, 0x00,	/* ******...... */
	0xfc, 0x00,	/* ******...... */
	0xfc, 0x00,	/* ******...... */
	0xfc, 0x00,	/* ******...... */
	0xfc, 0x00,	/* ******...... */
	0xfc, 0x00,	/* ******...... */
	0xfc, 0x00,	/* ******...... */
	0xfc, 0x00,	/* ******...... */
	0xfc, 0x00,	/* ******...... */
	0xfc, 0x00,	/* ******...... */
	0xfc, 0x00,	/* ******...... */
	0xfc, 0x00,	/* ******...... */
	0xfc, 0x00,	/* ******...... */
	0xfc, 0x00,	/* ******...... */
	0xfc, 0x00,	/* ******...... */
	0xfc, 0x00,	/* ******...... */
	0xfc, 0x00,	/* ******...... */
	0xfc, 0x00,	/* ******...... */
	0xfc, 0x00,	/* ******...... */
	0xfc, 0x00,	/* ******...... */
	0xfc, 0x00,	/* ******...... */
	0xfc, 0x00,	/* ******...... */

	/* 222 0xde '.' */
	0x03, 0xf0,	/* ......****** */
	0x03, 0xf0,	/* ......****** */
	0x03, 0xf0,	/* ......****** */
	0x03, 0xf0,	/* ......****** */
	0x03, 0xf0,	/* ......****** */
	0x03, 0xf0,	/* ......****** */
	0x03, 0xf0,	/* ......****** */
	0x03, 0xf0,	/* ......****** */
	0x03, 0xf0,	/* ......****** */
	0x03, 0xf0,	/* ......****** */
	0x03, 0xf0,	/* ......****** */
	0x03, 0xf0,	/* ......****** */
	0x03, 0xf0,	/* ......****** */
	0x03, 0xf0,	/* ......****** */
	0x03, 0xf0,	/* ......****** */
	0x03, 0xf0,	/* ......****** */
	0x03, 0xf0,	/* ......****** */
	0x03, 0xf0,	/* ......****** */
	0x03, 0xf0,	/* ......****** */
	0x03, 0xf0,	/* ......****** */
	0x03, 0xf0,	/* ......****** */
	0x03, 0xf0,	/* ......****** */

	/* 223 0xdf '.' */
	0xff, 0xf0,	/* ************ */
	0xff, 0xf0,	/* ************ */
	0xff, 0xf0,	/* ************ */
	0xff, 0xf0,	/* ************ */
	0xff, 0xf0,	/* ************ */
	0xff, 0xf0,	/* ************ */
	0xff, 0xf0,	/* ************ */
	0xff, 0xf0,	/* ************ */
	0xff, 0xf0,	/* ************ */
	0xff, 0xf0,	/* ************ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */

	/* 224 0xe0 '.' */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x3f, 0xc0,	/* ..********.. */
	0x3f, 0xc0,	/* ..********.. */
	0x3f, 0xc0,	/* ..********.. */
	0x3f, 0xc0,	/* ..********.. */
	0x3f, 0xc0,	/* ..********.. */
	0x3f, 0xc0,	/* ..********.. */
	0x3f, 0xc0,	/* ..********.. */
	0x3f, 0xc0,	/* ..********.. */
	0x3f, 0xc0,	/* ..********.. */
	0x3f, 0xc0,	/* ..********.. */
	0x3f, 0xc0,	/* ..********.. */
	0x3f, 0xc0,	/* ..********.. */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */

	/* 225 0xe1 '.' */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x0f, 0x00,	/* ....****.... */
	0x19, 0x80,	/* ...**..**... */
	0x30, 0xc0,	/* ..**....**.. */
	0x30, 0xc0,	/* ..**....**.. */
	0x30, 0xc0,	/* ..**....**.. */
	0x31, 0x80,	/* ..**...**... */
	0x37, 0x80,	/* ..**.****... */
	0x31, 0x80,	/* ..**...**... */
	0x30, 0xc0,	/* ..**....**.. */
	0x30, 0xc0,	/* ..**....**.. */
	0x30, 0xc0,	/* ..**....**.. */
	0x30, 0xc0,	/* ..**....**.. */
	0x31, 0x80,	/* ..**...**... */
	0x77, 0x00,	/* .***.***.... */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */

	/* 226 0xe2 '.' */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x3f, 0xc0,	/* ..********.. */
	0x3f, 0xc0,	/* ..********.. */
	0x3f, 0xc0,	/* ..********.. */
	0x3f, 0xc0,	/* ..********.. */
	0x3f, 0xc0,	/* ..********.. */
	0x3f, 0xc0,	/* ..********.. */
	0x3f, 0xc0,	/* ..********.. */
	0x3f, 0xc0,	/* ..********.. */
	0x3f, 0xc0,	/* ..********.. */
	0x3f, 0xc0,	/* ..********.. */
	0x3f, 0xc0,	/* ..********.. */
	0x3f, 0xc0,	/* ..********.. */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */

	/* 227 0xe3 '.' */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x3f, 0xc0,	/* ..********.. */
	0x3f, 0xc0,	/* ..********.. */
	0x3f, 0xc0,	/* ..********.. */
	0x3f, 0xc0,	/* ..********.. */
	0x3f, 0xc0,	/* ..********.. */
	0x3f, 0xc0,	/* ..********.. */
	0x3f, 0xc0,	/* ..********.. */
	0x3f, 0xc0,	/* ..********.. */
	0x3f, 0xc0,	/* ..********.. */
	0x3f, 0xc0,	/* ..********.. */
	0x3f, 0xc0,	/* ..********.. */
	0x3f, 0xc0,	/* ..********.. */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */

	/* 228 0xe4 '.' */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x3f, 0xc0,	/* ..********.. */
	0x3f, 0xc0,	/* ..********.. */
	0x3f, 0xc0,	/* ..********.. */
	0x3f, 0xc0,	/* ..********.. */
	0x3f, 0xc0,	/* ..********.. */
	0x3f, 0xc0,	/* ..********.. */
	0x3f, 0xc0,	/* ..********.. */
	0x3f, 0xc0,	/* ..********.. */
	0x3f, 0xc0,	/* ..********.. */
	0x3f, 0xc0,	/* ..********.. */
	0x3f, 0xc0,	/* ..********.. */
	0x3f, 0xc0,	/* ..********.. */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */

	/* 229 0xe5 '.' */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x3f, 0xc0,	/* ..********.. */
	0x3f, 0xc0,	/* ..********.. */
	0x3f, 0xc0,	/* ..********.. */
	0x3f, 0xc0,	/* ..********.. */
	0x3f, 0xc0,	/* ..********.. */
	0x3f, 0xc0,	/* ..********.. */
	0x3f, 0xc0,	/* ..********.. */
	0x3f, 0xc0,	/* ..********.. */
	0x3f, 0xc0,	/* ..********.. */
	0x3f, 0xc0,	/* ..********.. */
	0x3f, 0xc0,	/* ..********.. */
	0x3f, 0xc0,	/* ..********.. */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */

	/* 230 0xe6 '.' */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x30, 0xc0,	/* ..**....**.. */
	0x30, 0xc0,	/* ..**....**.. */
	0x30, 0xc0,	/* ..**....**.. */
	0x30, 0xc0,	/* ..**....**.. */
	0x30, 0xc0,	/* ..**....**.. */
	0x30, 0xc0,	/* ..**....**.. */
	0x30, 0xc0,	/* ..**....**.. */
	0x30, 0xc0,	/* ..**....**.. */
	0x39, 0xc0,	/* ..***..***.. */
	0x36, 0xe0,	/* ..**.**.***. */
	0x30, 0x00,	/* ..**........ */
	0x30, 0x00,	/* ..**........ */
	0x60, 0x00,	/* .**......... */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */

	/* 231 0xe7 '.' */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x3f, 0xc0,	/* ..********.. */
	0x3f, 0xc0,	/* ..********.. */
	0x3f, 0xc0,	/* ..********.. */
	0x3f, 0xc0,	/* ..********.. */
	0x3f, 0xc0,	/* ..********.. */
	0x3f, 0xc0,	/* ..********.. */
	0x3f, 0xc0,	/* ..********.. */
	0x3f, 0xc0,	/* ..********.. */
	0x3f, 0xc0,	/* ..********.. */
	0x3f, 0xc0,	/* ..********.. */
	0x3f, 0xc0,	/* ..********.. */
	0x3f, 0xc0,	/* ..********.. */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */

	/* 232 0xe8 '.' */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x3f, 0xc0,	/* ..********.. */
	0x3f, 0xc0,	/* ..********.. */
	0x3f, 0xc0,	/* ..********.. */
	0x3f, 0xc0,	/* ..********.. */
	0x3f, 0xc0,	/* ..********.. */
	0x3f, 0xc0,	/* ..********.. */
	0x3f, 0xc0,	/* ..********.. */
	0x3f, 0xc0,	/* ..********.. */
	0x3f, 0xc0,	/* ..********.. */
	0x3f, 0xc0,	/* ..********.. */
	0x3f, 0xc0,	/* ..********.. */
	0x3f, 0xc0,	/* ..********.. */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */

	/* 233 0xe9 '.' */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x3f, 0xc0,	/* ..********.. */
	0x3f, 0xc0,	/* ..********.. */
	0x3f, 0xc0,	/* ..********.. */
	0x3f, 0xc0,	/* ..********.. */
	0x3f, 0xc0,	/* ..********.. */
	0x3f, 0xc0,	/* ..********.. */
	0x3f, 0xc0,	/* ..********.. */
	0x3f, 0xc0,	/* ..********.. */
	0x3f, 0xc0,	/* ..********.. */
	0x3f, 0xc0,	/* ..********.. */
	0x3f, 0xc0,	/* ..********.. */
	0x3f, 0xc0,	/* ..********.. */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */

	/* 234 0xea '.' */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x3f, 0xc0,	/* ..********.. */
	0x3f, 0xc0,	/* ..********.. */
	0x3f, 0xc0,	/* ..********.. */
	0x3f, 0xc0,	/* ..********.. */
	0x3f, 0xc0,	/* ..********.. */
	0x3f, 0xc0,	/* ..********.. */
	0x3f, 0xc0,	/* ..********.. */
	0x3f, 0xc0,	/* ..********.. */
	0x3f, 0xc0,	/* ..********.. */
	0x3f, 0xc0,	/* ..********.. */
	0x3f, 0xc0,	/* ..********.. */
	0x3f, 0xc0,	/* ..********.. */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */

	/* 235 0xeb '.' */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x3f, 0xc0,	/* ..********.. */
	0x3f, 0xc0,	/* ..********.. */
	0x3f, 0xc0,	/* ..********.. */
	0x3f, 0xc0,	/* ..********.. */
	0x3f, 0xc0,	/* ..********.. */
	0x3f, 0xc0,	/* ..********.. */
	0x3f, 0xc0,	/* ..********.. */
	0x3f, 0xc0,	/* ..********.. */
	0x3f, 0xc0,	/* ..********.. */
	0x3f, 0xc0,	/* ..********.. */
	0x3f, 0xc0,	/* ..********.. */
	0x3f, 0xc0,	/* ..********.. */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */

	/* 236 0xec '.' */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x3f, 0xc0,	/* ..********.. */
	0x3f, 0xc0,	/* ..********.. */
	0x3f, 0xc0,	/* ..********.. */
	0x3f, 0xc0,	/* ..********.. */
	0x3f, 0xc0,	/* ..********.. */
	0x3f, 0xc0,	/* ..********.. */
	0x3f, 0xc0,	/* ..********.. */
	0x3f, 0xc0,	/* ..********.. */
	0x3f, 0xc0,	/* ..********.. */
	0x3f, 0xc0,	/* ..********.. */
	0x3f, 0xc0,	/* ..********.. */
	0x3f, 0xc0,	/* ..********.. */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */

	/* 237 0xed '.' */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x3f, 0xc0,	/* ..********.. */
	0x3f, 0xc0,	/* ..********.. */
	0x3f, 0xc0,	/* ..********.. */
	0x3f, 0xc0,	/* ..********.. */
	0x3f, 0xc0,	/* ..********.. */
	0x3f, 0xc0,	/* ..********.. */
	0x3f, 0xc0,	/* ..********.. */
	0x3f, 0xc0,	/* ..********.. */
	0x3f, 0xc0,	/* ..********.. */
	0x3f, 0xc0,	/* ..********.. */
	0x3f, 0xc0,	/* ..********.. */
	0x3f, 0xc0,	/* ..********.. */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */

	/* 238 0xee '.' */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x3f, 0xc0,	/* ..********.. */
	0x3f, 0xc0,	/* ..********.. */
	0x3f, 0xc0,	/* ..********.. */
	0x3f, 0xc0,	/* ..********.. */
	0x3f, 0xc0,	/* ..********.. */
	0x3f, 0xc0,	/* ..********.. */
	0x3f, 0xc0,	/* ..********.. */
	0x3f, 0xc0,	/* ..********.. */
	0x3f, 0xc0,	/* ..********.. */
	0x3f, 0xc0,	/* ..********.. */
	0x3f, 0xc0,	/* ..********.. */
	0x3f, 0xc0,	/* ..********.. */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */

	/* 239 0xef '.' */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x3f, 0xc0,	/* ..********.. */
	0x3f, 0xc0,	/* ..********.. */
	0x3f, 0xc0,	/* ..********.. */
	0x3f, 0xc0,	/* ..********.. */
	0x3f, 0xc0,	/* ..********.. */
	0x3f, 0xc0,	/* ..********.. */
	0x3f, 0xc0,	/* ..********.. */
	0x3f, 0xc0,	/* ..********.. */
	0x3f, 0xc0,	/* ..********.. */
	0x3f, 0xc0,	/* ..********.. */
	0x3f, 0xc0,	/* ..********.. */
	0x3f, 0xc0,	/* ..********.. */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */

	/* 240 0xf0 '.' */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x3f, 0xc0,	/* ..********.. */
	0x3f, 0xc0,	/* ..********.. */
	0x3f, 0xc0,	/* ..********.. */
	0x3f, 0xc0,	/* ..********.. */
	0x3f, 0xc0,	/* ..********.. */
	0x3f, 0xc0,	/* ..********.. */
	0x3f, 0xc0,	/* ..********.. */
	0x3f, 0xc0,	/* ..********.. */
	0x3f, 0xc0,	/* ..********.. */
	0x3f, 0xc0,	/* ..********.. */
	0x3f, 0xc0,	/* ..********.. */
	0x3f, 0xc0,	/* ..********.. */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */

	/* 241 0xf1 '.' */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x06, 0x00,	/* .....**..... */
	0x06, 0x00,	/* .....**..... */
	0x06, 0x00,	/* .....**..... */
	0x06, 0x00,	/* .....**..... */
	0x7f, 0xe0,	/* .**********. */
	0x7f, 0xe0,	/* .**********. */
	0x06, 0x00,	/* .....**..... */
	0x06, 0x00,	/* .....**..... */
	0x06, 0x00,	/* .....**..... */
	0x06, 0x00,	/* .....**..... */
	0x00, 0x00,	/* ............ */
	0x7f, 0xe0,	/* .**********. */
	0x7f, 0xe0,	/* .**********. */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */

	/* 242 0xf2 '.' */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x3f, 0xc0,	/* ..********.. */
	0x3f, 0xc0,	/* ..********.. */
	0x3f, 0xc0,	/* ..********.. */
	0x3f, 0xc0,	/* ..********.. */
	0x3f, 0xc0,	/* ..********.. */
	0x3f, 0xc0,	/* ..********.. */
	0x3f, 0xc0,	/* ..********.. */
	0x3f, 0xc0,	/* ..********.. */
	0x3f, 0xc0,	/* ..********.. */
	0x3f, 0xc0,	/* ..********.. */
	0x3f, 0xc0,	/* ..********.. */
	0x3f, 0xc0,	/* ..********.. */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */

	/* 243 0xf3 '.' */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x3f, 0xc0,	/* ..********.. */
	0x3f, 0xc0,	/* ..********.. */
	0x3f, 0xc0,	/* ..********.. */
	0x3f, 0xc0,	/* ..********.. */
	0x3f, 0xc0,	/* ..********.. */
	0x3f, 0xc0,	/* ..********.. */
	0x3f, 0xc0,	/* ..********.. */
	0x3f, 0xc0,	/* ..********.. */
	0x3f, 0xc0,	/* ..********.. */
	0x3f, 0xc0,	/* ..********.. */
	0x3f, 0xc0,	/* ..********.. */
	0x3f, 0xc0,	/* ..********.. */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */

	/* 244 0xf4 '.' */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x3f, 0xc0,	/* ..********.. */
	0x3f, 0xc0,	/* ..********.. */
	0x3f, 0xc0,	/* ..********.. */
	0x3f, 0xc0,	/* ..********.. */
	0x3f, 0xc0,	/* ..********.. */
	0x3f, 0xc0,	/* ..********.. */
	0x3f, 0xc0,	/* ..********.. */
	0x3f, 0xc0,	/* ..********.. */
	0x3f, 0xc0,	/* ..********.. */
	0x3f, 0xc0,	/* ..********.. */
	0x3f, 0xc0,	/* ..********.. */
	0x3f, 0xc0,	/* ..********.. */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */

	/* 245 0xf5 '.' */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x3f, 0xc0,	/* ..********.. */
	0x3f, 0xc0,	/* ..********.. */
	0x3f, 0xc0,	/* ..********.. */
	0x3f, 0xc0,	/* ..********.. */
	0x3f, 0xc0,	/* ..********.. */
	0x3f, 0xc0,	/* ..********.. */
	0x3f, 0xc0,	/* ..********.. */
	0x3f, 0xc0,	/* ..********.. */
	0x3f, 0xc0,	/* ..********.. */
	0x3f, 0xc0,	/* ..********.. */
	0x3f, 0xc0,	/* ..********.. */
	0x3f, 0xc0,	/* ..********.. */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */

	/* 246 0xf6 '.' */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x06, 0x00,	/* .....**..... */
	0x06, 0x00,	/* .....**..... */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x7f, 0xe0,	/* .**********. */
	0x7f, 0xe0,	/* .**********. */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x06, 0x00,	/* .....**..... */
	0x06, 0x00,	/* .....**..... */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */

	/* 247 0xf7 '.' */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x3f, 0xc0,	/* ..********.. */
	0x3f, 0xc0,	/* ..********.. */
	0x3f, 0xc0,	/* ..********.. */
	0x3f, 0xc0,	/* ..********.. */
	0x3f, 0xc0,	/* ..********.. */
	0x3f, 0xc0,	/* ..********.. */
	0x3f, 0xc0,	/* ..********.. */
	0x3f, 0xc0,	/* ..********.. */
	0x3f, 0xc0,	/* ..********.. */
	0x3f, 0xc0,	/* ..********.. */
	0x3f, 0xc0,	/* ..********.. */
	0x3f, 0xc0,	/* ..********.. */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */

	/* 248 0xf8 '.' */
	0x00, 0x00,	/* ............ */
	0x0f, 0x00,	/* ....****.... */
	0x19, 0x80,	/* ...**..**... */
	0x19, 0x80,	/* ...**..**... */
	0x19, 0x80,	/* ...**..**... */
	0x0f, 0x00,	/* ....****.... */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */

	/* 249 0xf9 '.' */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x3f, 0xc0,	/* ..********.. */
	0x3f, 0xc0,	/* ..********.. */
	0x3f, 0xc0,	/* ..********.. */
	0x3f, 0xc0,	/* ..********.. */
	0x3f, 0xc0,	/* ..********.. */
	0x3f, 0xc0,	/* ..********.. */
	0x3f, 0xc0,	/* ..********.. */
	0x3f, 0xc0,	/* ..********.. */
	0x3f, 0xc0,	/* ..********.. */
	0x3f, 0xc0,	/* ..********.. */
	0x3f, 0xc0,	/* ..********.. */
	0x3f, 0xc0,	/* ..********.. */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */

	/* 250 0xfa '.' */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x06, 0x00,	/* .....**..... */
	0x0f, 0x00,	/* ....****.... */
	0x0f, 0x00,	/* ....****.... */
	0x06, 0x00,	/* .....**..... */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */

	/* 251 0xfb '.' */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x3f, 0xc0,	/* ..********.. */
	0x3f, 0xc0,	/* ..********.. */
	0x3f, 0xc0,	/* ..********.. */
	0x3f, 0xc0,	/* ..********.. */
	0x3f, 0xc0,	/* ..********.. */
	0x3f, 0xc0,	/* ..********.. */
	0x3f, 0xc0,	/* ..********.. */
	0x3f, 0xc0,	/* ..********.. */
	0x3f, 0xc0,	/* ..********.. */
	0x3f, 0xc0,	/* ..********.. */
	0x3f, 0xc0,	/* ..********.. */
	0x3f, 0xc0,	/* ..********.. */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */

	/* 252 0xfc '.' */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x3f, 0xc0,	/* ..********.. */
	0x3f, 0xc0,	/* ..********.. */
	0x3f, 0xc0,	/* ..********.. */
	0x3f, 0xc0,	/* ..********.. */
	0x3f, 0xc0,	/* ..********.. */
	0x3f, 0xc0,	/* ..********.. */
	0x3f, 0xc0,	/* ..********.. */
	0x3f, 0xc0,	/* ..********.. */
	0x3f, 0xc0,	/* ..********.. */
	0x3f, 0xc0,	/* ..********.. */
	0x3f, 0xc0,	/* ..********.. */
	0x3f, 0xc0,	/* ..********.. */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */

	/* 253 0xfd '.' */
	0x00, 0x00,	/* ............ */
	0x0f, 0x00,	/* ....****.... */
	0x1f, 0x80,	/* ...******... */
	0x31, 0x80,	/* ..**...**... */
	0x21, 0x80,	/* ..*....**... */
	0x03, 0x00,	/* ......**.... */
	0x06, 0x00,	/* .....**..... */
	0x0c, 0x00,	/* ....**...... */
	0x18, 0x40,	/* ...**....*.. */
	0x3f, 0xc0,	/* ..********.. */
	0x3f, 0xc0,	/* ..********.. */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */

	/* 254 0xfe '.' */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x3f, 0xc0,	/* ..********.. */
	0x3f, 0xc0,	/* ..********.. */
	0x3f, 0xc0,	/* ..********.. */
	0x3f, 0xc0,	/* ..********.. */
	0x3f, 0xc0,	/* ..********.. */
	0x3f, 0xc0,	/* ..********.. */
	0x3f, 0xc0,	/* ..********.. */
	0x3f, 0xc0,	/* ..********.. */
	0x3f, 0xc0,	/* ..********.. */
	0x3f, 0xc0,	/* ..********.. */
	0x3f, 0xc0,	/* ..********.. */
	0x3f, 0xc0,	/* ..********.. */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */

	/* 255 0xff '.' */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	0x00, 0x00,	/* ............ */
	}
};
